' Maezumo Copyright (C) 2009 Christian Schmidt
' Version 1.10 - changes at end of source
'
' Maezumo is free software: you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation, either version 3 of the License, or
' (at your option) any later version.
' 
' Maezumo is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program.  If not, see <http://www.gnu.org/licenses/>.
'
#lang "fblite"
#INCLUDE "file.bi"
Option GoSub
Dim UseWin As Integer

'========= Configure next line for OS ================.
UseWin = 0  'UseWin=1 for Windows, UseWin=0 for Linux |
'====================================================='

Dim PathSym As String  '1.01e1 - all usages of PathSym and UseWin
PathSym = "/" : If UseWin Then PathSym = "\"

RANDOMIZE TIMER
'*** Define Warrior Variables *******************************
Dim WarriorFile (1 to 1000) as string
Dim WarriorName (1 to 1000) as string
Dim WarriorAuthor (1 to 1000) as string
Dim WarriorType (1 to 1000) as string
Dim WarriorResult (1 to 1000) as Integer
Dim WarriorScoring(1 to 1000) As Single
Dim WarriorSeed As String
Dim WarriorSeedA As string
Dim WarriorSeedB As String

Dim WarriorTmpFile As String
WarriorTmpFile="tmp.red"

Dim WarriorWin (1 to 1000) as Integer
Dim WarriorTie (1 to 1000) as Integer
Dim WarriorLoss (1 to 1000) as Integer

'*** Define Hill Variables *************************
Dim HillSize As Integer
Dim HillAge As Integer
Dim HillBattleNo As Single
Dim WarriorNew As Integer

'*** Define exmars parameter ***********************
Dim BattleRounds As Integer
Dim BattleEvoRounds As integer
Dim MaxProcesses As Integer
Dim CoreSize As Integer
Dim MaxCycle As Integer
Dim MaxLen As Integer
Dim MinDist As Integer
Dim BattleCommand As String
Dim BattleEvoCommand As String
Dim BattleF As Integer 'For random generation of the -F number
Dim Mars As String     '1.02x2 - to specify sim binary
Mars = "exmars"        'default to exmars if not specified

Dim BattleWin As Integer
Dim BattleTie As Integer
Dim BattleLoss As Integer

'*** Define Auxiliaries ****************************
Dim CounterA As Integer
Dim CounterB As Integer
Dim CounterC As Integer
Dim CounterD As Integer
Dim CounterE As Integer
Dim CounterF As Integer
Dim CounterX (1 to 20) As Integer

Dim RTime As Integer
Dim ReadOut As String
Dim ReadOut2 As String
Dim ReadOut3 As String

Dim TempStoreTxt As String
Dim TempStoreInt As Integer
Dim TempStoreSing As Single
Dim TempInt2 As Integer '1.01e1

Dim StageOneRatio As Integer ' sub-routin counter of species before enter the hill
Dim AllSpecies As Integer ' all generated warriors


'*** Define Evolving Parameter *********************

dim BattleThreshold As Integer
Dim BattleAdvance As Integer

Dim EvoOpcode (1 to 200) as String

Dim EvoTpA (1 to 20) as Integer
Dim EvoTpB (1 to 20) as Integer

Dim EvoAdressing (1 to 20) as String

Dim NumStart As Integer ' 1 or 2 times
Dim NumEnd As Integer '0 or 1 times
Dim NumLen As Integer

Dim LnOp As String
Dim LnMoA As String
Dim LnMoB As String
Dim LnVaA As Integer
Dim LnVaB As Integer

Dim ProbSpl As Integer
Dim ProbMov As Integer
Dim ProbAdd As Integer
Dim ProbSne As Integer
Dim ProbSeq As Integer

Dim ProbDjn As Integer
Dim ProbJmn As Integer
Dim ProbJmz As Integer
Dim ProbJmp As Integer

Dim EvoLen As Integer
Dim CounterEvoLen As Integer
Dim CounterEvoType As Integer
Dim HintMode As Integer
Dim IniHintMode As integer
Dim HillSave As Integer
Dim HillFreeze As Integer
Dim KothNumber As Integer
Dim CounterImp As Integer

'1.10 define optimizer constants
Dim OptimiNo As Integer
Dim OptimiName (1 To 10) As String
Dim OptimiMin (1 To 10) As Integer
Dim OptimiMax (1 To 10) As Integer


'1.04cs define hint mode probability
Dim HintProb(0 to 4) as Integer
HintProb(0)=1000
HintProb(1)=1000
HintProb(2)=1000
HintProb(3)=1000
HintProb(4)=1000

Dim TakeOver As Integer '1.06cs
Dim TakePerc As Integer '1.06cs

Dim EmbeddingOn As Integer '1.05cs
Dim EmbeddingLen As Integer '1.05cs

'*** Mutation Parameter
Dim SoupSize As Integer
Dim SoupEntry As Integer
Dim EnableMutation As Integer
Dim MutateByProbability As Integer
Dim MutationSelect As Single
Dim MinChanges As Integer
Dim MutationRate As Single
Dim InstrRate As Single
Dim AddrRate As Single
Dim DataRate As Single
Dim InsertRate As Single
Dim DeleteRate As Single
Dim DupLineChance As Single
Dim IncDecChance As Single
Dim BigNumChance As Single
Dim CountOfChanges As Integer
Dim ProbDat As Integer
Dim I As Integer
Dim J As Integer
Dim K As Integer
Dim PrevValue As Integer
Dim NewValue As Integer
Dim SoupEntry1 As Integer
Dim SoupEntry2 As Integer
Dim WarFilename As String
Dim SoupIterations As Integer
Dim SoupIterCount As Integer
Dim SoupRounds As Integer  '1.01e1
Dim SoupCommand As String  '1.01e1
Dim SaveSoup As Integer
Dim NumberOfInstructions As Integer
NumberOfInstructions = 16 'for default, increased under array for added opcodes
Dim NumberOfAddressModes As Integer
NumberOfAddressModes = 8  'for default, increased under array for added modes

'Default mutation variables
SoupSize = 100        'size of internal soup
EnableMutation = 1    'default mutate on
MutationSelect = 0.5  '0 to 1 - how often mutation selected instead of hint
MinChanges = 1        'make at least this many changes or reject mutant
MutationRate = 1      'multiply mutation rates by this when reading INI
InstrRate = 0.01      '0 to 1 - chance of instruction change per line
AddrRate = 0.03       '0 to 1 - chance of address mode change per item
DataRate = 0.05       '0 to 1 - chance of data value change per item
InsertRate = 0.01     '0 to 1 - chance of inserted line per line
DeleteRate = 0.01     '0 to 1 - chance of deleted line per line
DupLineChance = 0.2   '0 to 1 - chance of inserted line being a mutated duplicate
IncDecChance = 0.5    '0 to 1 - for data how often to inc/dec rather than random #
BigNumChance = 0.5    '0 to 1 - for data if random how often to choose big #
MutateByProbability = 0  '0 or 1, if 1 use probability settings from INI
ProbDat = 100   'extra probability for dat
SoupIterations = 20 'how many soup iterations for each soup test

'1.02x3(+) - new mutation/soup parameters...
Dim EnableSeed As Integer  '0 or 1 - if 1 warriors that make hill added to soup
Dim SwapRate As Single     '0 to 1 - chance of swapping two instruction lines
Dim Topology As Integer    '0 to coresize-1 - 0=grid else max battle distance on ring
Dim SoupDisplay As Integer '0=none 1=cells 2=narrow blocks 3=wide blocks
Dim SoupX As Integer    'used for grid soup - square root of soup size
Dim SoupWins As Integer 'number of soup battle wins needed to mutate
EnableSeed = 1    'default is previous behavior with old INI files
SwapRate = 0
Topology = 4
SoupDisplay = 0
SoupX = 0
SoupWins = 0
'soup display variables...
Dim HashI As Integer    'course hash of instruction sequence
Dim HashM As Integer    'hash of address modes
Dim HashA As Integer    'hash of A data values
Dim HashB As Integer    'hash of B data values
Dim WarriorColor As String 'hex color value
Dim CHexColors As String 'course hex digits
Dim FHexColors As String 'fine hex digits
CHexColors = "23456789ABCD"
FHexColors = "0123456789ABCDEF"
Dim WarriorCell As String
Dim C1 As Integer 'for figuring out cell colors
Dim C2 As Integer
Dim C3 As Integer
Dim SDcustom As String '1.02x4 more vars...
Dim EnableSW As Integer
Dim SWposition As Integer
Dim SWcolor As String
Dim LineHeight As String '1.04x7
SDcustom = "@"
EnableSW = 1
'1.04x8... "valhalla" variables
Dim ReInsMode As Integer '0=off 1=random 2=koth 3=high score
'added options 4=topscore.red 5=from species directory
Dim ReInsChance As Single '0 to 1, chance of re-insertion per stage-1 iteration
ReInsMode = 0
ReInsChance = 0.05
Dim RItopPerc As Integer '1.06x14

'*** Variables for benchmarking and statistics '1.01e1
Dim EnableBench As Integer
Dim BenchDir As String
Dim ShowExtra As Integer
Dim BenchWarrior As String
Dim Origin As String
Dim GenCount As Integer
Dim BenchScore As Single
Dim HillOrigin (1 to 1000) As String
Dim HillGenCount (1 to 1000) As Integer
Dim HillBenchScore (1 to 1000) As Single
EnableBench = 0   '0 or 1 - disable/enable benchmarking feature
BenchDir = ""     'directory containing benchmark warriors
ShowExtra = 0     '0 or 1 - show extra info in HTML report
'1.01e1a for better bench behavior
Dim BenchDirName As String
Dim BenchMask(1 to 20) As String
Dim NumBenchMasks As Integer
BenchMask(1) = "*.red"  'warrior extensions (lowercase)
BenchMask(2) = "*.war"
BenchMask(3) = "*.rc"
NumBenchMasks = 3
If UseWin = 0 Then     'if Linux, add uppercase versions too
 For I = 1 To NumBenchMasks
  BenchMask(I + NumBenchMasks) = UCase(BenchMask(I))
 Next
 NumBenchMasks = NumBenchMasks * 2
EndIf
'1.05x10 - variables for saving top warrior/score
Dim TopScore As Single  'best score in run
Dim DisplayTS As Integer 'show topscore.red in html  1.06x15

'####################################Initialize###########################################################################################
Print "Evolution has started."
Print "It may take a while until you see first results."

'----- Read initial ini-file with data

Open "Maezumo.ini" For Input As #1
Do
	Input #1, ReadOut
	IF LEFT(ReadOut,12)="author     :" THEN WarriorSeedA=Right(ReadOut,Len(ReadOut)-12)
	IF LEFT(ReadOut,12)="type       :" THEN WarriorSeedB=Right(ReadOut,Len(ReadOut)-12)
	IF LEFT(ReadOut,12)="evo rounds :" THEN BattleEvoRounds=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="hill rounds:" THEN BattleRounds=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="max. proc  :" THEN MaxProcesses=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="coresize   :" THEN CoreSize=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="max. cycle :" THEN MaxCycle=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="max. len   :" THEN MaxLen=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="min. dist  :" THEN MinDist=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="hillsize   :" THEN HillSize=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="spl        :" THEN ProbSpl=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="mov        :" THEN ProbMov=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="add        :" THEN ProbAdd=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="sne        :" THEN ProbSne=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="seq        :" THEN ProbSeq=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="djn        :" THEN ProbDjn=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="jmn        :" THEN ProbJmn=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="jmz        :" THEN ProbJmz=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="jmp        :" THEN ProbJmp=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="evo len    :" THEN EvoLen=Val(Right(ReadOut,Len(ReadOut)-12))	
	IF LEFT(ReadOut,12)="hint mode  :" THEN HintMode=Val(Right(ReadOut,Len(ReadOut)-12))
	If LEFT(ReadOut,12)="hill save  :" THEN HillSave=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="hill freeze:" THEN HillFreeze=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="No of koth :" THEN KothNumber=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="SoupSize   :" THEN SoupSize=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="Mutation   :" THEN EnableMutation=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="MutSelect  :" THEN MutationSelect=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="MinChanges :" THEN MinChanges=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="MutRate    :" THEN MutationRate=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="InstrRate  :" THEN InstrRate=Val(Right(ReadOut,Len(ReadOut)-12))*MutationRate
	IF LEFT(ReadOut,12)="AddrRate   :" THEN AddrRate=Val(Right(ReadOut,Len(ReadOut)-12))*MutationRate
	IF LEFT(ReadOut,12)="DataRate   :" THEN DataRate=Val(Right(ReadOut,Len(ReadOut)-12))*MutationRate
	IF LEFT(ReadOut,12)="InsertRate :" THEN InsertRate=Val(Right(ReadOut,Len(ReadOut)-12))*MutationRate
	IF LEFT(ReadOut,12)="DeleteRate :" THEN DeleteRate=Val(Right(ReadOut,Len(ReadOut)-12))*MutationRate
	IF LEFT(ReadOut,12)="DupLine    :" THEN DupLineChance=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="IncDec     :" THEN IncDecChance=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="BigNum     :" THEN BigNumChance=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="MutByProb  :" THEN MutateByProbability=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="dat        :" THEN ProbDat=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="SoupIter   :" THEN SoupIterations=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="SaveSoup   :" THEN SaveSoup=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="EnableBench:" THEN EnableBench=Val(Right(ReadOut,Len(ReadOut)-12)) '1.01e1
	IF LEFT(ReadOut,12)="BenchDir   :" THEN BenchDir=Right(ReadOut,Len(ReadOut)-12)         '1.01e1
	IF LEFT(ReadOut,12)="ShowExtra  :" THEN ShowExtra=Val(Right(ReadOut,Len(ReadOut)-12))   '1.01e1
	IF LEFT(ReadOut,12)="SoupRounds :" THEN SoupRounds=Val(Right(ReadOut,Len(ReadOut)-12))  '1.01e1
	IF LEFT(ReadOut,12)="mars       :" THEN Mars=Right(ReadOut,Len(ReadOut)-12)             '1.02x2
	IF LEFT(ReadOut,12)="Topology   :" THEN Topology=Val(Right(ReadOut,Len(ReadOut)-12))    '1.02x3
	IF LEFT(ReadOut,12)="EnableSeed :" THEN EnableSeed=Val(Right(ReadOut,Len(ReadOut)-12))  '1.02x3
	IF LEFT(ReadOut,12)="SoupX      :" Then SoupX=Val(Right(ReadOut,Len(ReadOut)-12))       '1.02x3
	IF LEFT(ReadOut,12)="SoupDisplay:" THEN SoupDisplay=Val(Right(ReadOut,Len(ReadOut)-12)) '1.02x3
	IF LEFT(ReadOut,12)="SwapRate   :" THEN SwapRate=Val(Right(ReadOut,Len(ReadOut)-12))*MutationRate '1.02x3
	IF LEFT(ReadOut,12)="SDcustom   :" THEN SDcustom=Right(ReadOut,Len(ReadOut)-12)         '1.02x4
	IF LEFT(ReadOut,12)="SW Display :" THEN EnableSW=Val(Right(ReadOut,Len(ReadOut)-12))    '1.02x4
	IF LEFT(ReadOut,12)="SoupWins   :" THEN SoupWins=Val(Right(ReadOut,Len(ReadOut)-12))    '1.02x6
	IF LEFT(ReadOut,12)="hint-pur   :" THEN HintProb (0)=Val(Right(ReadOut,Len(ReadOut)-12))'1.04cs
	IF LEFT(ReadOut,12)="hint-pap   :" THEN HintProb (1)=Val(Right(ReadOut,Len(ReadOut)-12))'1.04cs
	IF LEFT(ReadOut,12)="hint-sca   :" THEN HintProb (2)=Val(Right(ReadOut,Len(ReadOut)-12))'1.04cs
	IF LEFT(ReadOut,12)="hint-fra   :" THEN HintProb (3)=Val(Right(ReadOut,Len(ReadOut)-12))'1.04cs
	IF LEFT(ReadOut,12)="hint-sto   :" THEN HintProb (4)=Val(Right(ReadOut,Len(ReadOut)-12))'1.04cs
	IF LEFT(ReadOut,12)="Embedding  :" THEN EmbeddingOn=Val(Right(ReadOut,Len(ReadOut)-12)) '1.05cs
	IF LEFT(ReadOut,12)="ReInsMode  :" THEN ReInsMode=Val(Right(ReadOut,Len(ReadOut)-12))   '1.04x8
	IF LEFT(ReadOut,12)="ReInsChance:" THEN ReInsChance=Val(Right(ReadOut,Len(ReadOut)-12)) '1.04x8
	IF LEFT(ReadOut,12)="TakeOver   :" THEN TakeOver=Val(Right(ReadOut,Len(ReadOut)-12)) '1.06cs
	IF LEFT(ReadOut,12)="TakePerc   :" THEN TakePerc=Val(Right(ReadOut,Len(ReadOut)-12)) '1.06cs
	IF LEFT(ReadOut,12)="RItopPerc  :" THEN RItopPerc=Val(Right(ReadOut,Len(ReadOut)-12)) '1.06x14
	IF LEFT(ReadOut,12)="DisplayTS  :" THEN DisplayTS=Val(Right(ReadOut,Len(ReadOut)-12)) '1.06x15

Loop Until Eof (1)
Close #1

'1.01e1 - redid INI error checking (not everything is validated)
TempInt2=0 'error flag
If HintMode=9 Then EnableMutation=0 'deactivate mutation for HintMode 9 1.10
If SoupSize>10000 Or SoupSize<5 Or SoupSize<Topology+1 Then
 Print "'SoupSize' is out of range" : TempInt2=1
EndIf
If HillSize<2 Or HillSize>1000 Then Print "'hillsize' is out of range" : TempInt2=1
If EvoLen>1000 Or EvoLen<1 Then Print "'evo len' is out of range" : TempInt2=1
If HintMode>0 And EvoLen<5 Then '1.05cs
 Print "To use the hint-modes the 'evo len' must be at least 5" : TempInt2=1
EndIf
If HintMode<0 Or HintMode>9 Or (HintMode>4 And HintMode<7) Then
 Print "Invalid hint mode" : TempInt2=1
EndIf
If SaveSoup<0 Or SaveSoup>2 Then Print "Invalid SaveSoup mode" : TempInt2=1
If EnableBench Then 'mod 1.01e1a to support specific masks
 ReadOut = ""
 For I = 1 To NumBenchMasks
  If ReadOut = "" Then ReadOut = Dir (BenchDir+PathSym+BenchMask(I))
 Next
 If ReadOut = "" Then Print "No benchmark warriors found" : TempInt2=1
EndIf
'1.02x2 validate Mars parm...
TempStoreInt=Instr(Mars," ")
If TempStoreInt Then
 If Left(Mars,1)<>Chr(34) And Right(Mars,1)<>Chr(34) Then
  Print "Spaces not allowed in mars parameter unless quoted" : TempInt2=1
 EndIf
EndIf
TempStoreTxt=Lcase(Mars)
TempStoreInt=Instr(TempStoreTxt,"mars")
If TempStoreInt=0 Then Print "mars parameter must contain 'mars'" : TempInt2=1
'1.02x3 validate new topology variables
If Topology < 0 Or Topology > SoupSize-1 Then
 Print "Topology must be from 0 to SoupSize-1" : TempInt2=1
EndIf
If Topology = 0 And (SoupX < 0 Or SoupX > Int(SoupSize/2)) Then
 Print "SoupX must be from 0 to SoupSize/2" : TempInt2=1
EndIf

If TempInt2 Then 'if error in INI file detected
 Sleep
 End
EndIf

If SoupX <= 0 Then SoupX = Int(Sqr(SoupSize)) '1.02x3

If EnableBench Then '1.01e1a
  BenchDirName=BenchDir  ' don't display path in HTML/warrior comments
  TempStoreInt=InStr(BenchDirName,PathSym) ' just the base name to
  While TempStoreInt > 0                   ' avoid making the display too wide
    BenchDirName=Mid(BenchDirName,TempStoreInt+1)
    TempStoreInt=InStr(BenchDirName,PathSym)
  Wend
  '1.05x10 - if top score warrior exists determine bench score
  Open "topscore.red" For Input As #1
  While Not Eof(1)
    Line Input #1, ReadOut
    If Left(ReadOut,12)=";benchscore " Then TopScore = Val(Mid(ReadOut,13,6)) + 0.0001
  Wend
  Close #1
EndIf

IniHintMode = HintMode

Dim SpeciesCode (1 To 9, 1 To EvoLen) As Integer

'----- Read the number of evolution cycles ----
Open "evo.ini" FOR INPUT AS #1
INPUT #1,readout
AllSpecies=Val(readout)+1
Close #1

'------ Check hillsize with warrior.ini

CounterA = 0
CounterB = 0
Open "warrior.ini" FOR INPUT AS #1

While Not Eof (1)
	CounterA = CounterA + 1
   INPUT #1,WarriorFile(CounterA)
Wend
Close #1

If CounterA < HillSize Then 
	Open "warrior.ini" For OUTPUT AS #1
	CounterC=0
	
	While CounterC < CounterA
		CounterC=CounterC+1
		Print #1, WarriorFile(CounterC)
	Wend

'---- Fill the hill with bots if hillsize larger than the banzuke list	
	Do
		CounterA = CounterA + 1
		Open "files"+PathSym+"bot.red" FOR INPUT AS #2
		TempStoreTxt="bot"+Str(CounterA)+".red"
		print #1, TempStoreTxt
		Open TempStoreTxt For Output As #3
		
		Do
			Line Input #2, ReadOut
			Print #3, ReadOut
		Loop Until Eof (2)
		
		Close #3
		Close #2
		
	Loop Until CounterA=HillSize
	Close #1  '1.01
End if	


'####################################Start Evolve#########################################################################################

EvoOpcode (1) = "spl.b "	'a:int / b:ext
EvoOpcode (2) = "mov.i "	'a:int / b:ext
EvoOpcode (3) = "add.f "	'a:ext / b:int
EvoOpcode (4) = "sne.i "	'a:ext / b:ext
EvoOpcode (5) = "seq.i "	'a:ext / b:ext
EvoOpcode (6) = "djn.f "	'a:int / b:ext
EvoOpcode (7) = "djn.b "	'a:int / b:ext
EvoOpcode (8) = "jmn.f "	'a:int / b:ext
EvoOpcode (9) = "jmp.b "	'a:int / b:ext
EvoOpcode (10) = "dat.f " 	'a/b:int / ext
EvoOpcode (11) = "mov.i " 	'a:ext / b:ext
EvoOpcode (12) = "jmz.f " 	'a:int / b:ext
EvoOpcode (13) = "add.ab" 	'a:int / b:ext
EvoOpcode (14) = "jmz.a " 	'a:int / b:ext
EvoOpcode (15) = "mov.b " 	'a:int / b:ext
EvoOpcode (16) = "add.a " 	'a:int / b:ext
EvoOpcode (17) = "spl.a "
EvoOpcode (18) = "spl.b "
EvoOpcode (19) = "spl.x "
EvoOpcode (20) = "spl.f "
EvoOpcode (21) = "spl.ab"
EvoOpcode (22) = "jmn.a "'1.06cs
EvoOpcode (23) = "mov.a "
EvoOpcode (24) = "mov.x "
EvoOpcode (25) = "mov.f "
EvoOpcode (26) = "mov.ab"
EvoOpcode (27) = "mov.ba"
EvoOpcode (28) = "spl   "
EvoOpcode (29) = "spl   "
EvoOpcode (30) = "spl   "
EvoOpcode (31) = "spl   "
EvoOpcode (32) = "spl   "
EvoOpcode (33) = "spl   "
EvoOpcode (34) = "mov   "
EvoOpcode (35) = "mov   "
EvoOpcode (36) = "mov   "
EvoOpcode (37) = "mov   "
EvoOpcode (38) = "mov   "
EvoOpcode (39) = "mov   "
EvoOpcode (40) = "mov   "
EvoOpcode (41) = "mov   "
EvoOpcode (42) = "dat   "
EvoOpcode (43) = "dat   "
EvoOpcode (44) = "add.f "
EvoOpcode (45) = "sub.x "'1.05
EvoOpcode (46) = "mul   "
EvoOpcode (47) = "div   "
EvoOpcode (48) = "mod   "
EvoOpcode (49) = "jmp   "
EvoOpcode (50) = "jmn   "
EvoOpcode (51) = "jmz   "
EvoOpcode (52) = "seq   "
EvoOpcode (53) = "sne   "
EvoOpcode (54) = "slt   "
EvoOpcode (55) = "djn   "
EvoOpcode (56) = "djn.a "
EvoOpcode (57) = "djn.x "
EvoOpcode (58) = "nop   " '1.02x1a
NumberOfInstructions = 58 'overrides previous default setting of 16

EvoTpA (1) = (EvoLen*2)
EvoTpA (2) = (EvoLen*2)
EvoTpA (3) = (CoreSize/2)
EvoTpA (4) = (CoreSize/2)
EvoTpA (5) = (CoreSize/2)
EvoTpA (6) = (EvoLen*2)
EvoTpA (7) = (EvoLen*2)
EvoTpA (8) = (EvoLen*2)
EvoTpA (9) = (EvoLen*2)
EvoTpA (10) = (CoreSize/2)
EvoTpA (11) = (CoreSize/2)
EvoTpA (12) = (EvoLen*2)

EvoTpB (1) = (CoreSize/2)
EvoTpB (2) = (EvoLen*2)
EvoTpB (3) = (EvoLen*2)
EvoTpB (4) = (CoreSize/2)
EvoTpB (5) = (CoreSize/2)
EvoTpB (6) = (CoreSize/2)
EvoTpB (7) = (CoreSize/2)
EvoTpB (8) = (CoreSize/2)
EvoTpB (9) = (CoreSize/2)
EvoTpB (10) = (CoreSize/2)
EvoTpB (11) = (CoreSize/2)
EvoTpB (12) = (CoreSize/2)

EvoAdressing (1) = "$"
EvoAdressing (2) = "@"
EvoAdressing (3) = "#"
EvoAdressing (4) = "<"
EvoAdressing (5) = ">"
EvoAdressing (6) = "{"
EvoAdressing (7) = "}"
EvoAdressing (8) = "*"
EvoAdressing (9) = "$"
EvoAdressing (10) = "$"
NumberOfAddressModes = 10 'overrides previous default setting of 8

Dim SoupCode (1 To SoupSize, 1 To 5, 1 To MaxLen) As Integer
Dim SoupOrigin (1 To SoupSize) As String    '1.01e1
Dim SoupGenCount (1 To SoupSize) As Integer '1.01e1
If EnableMutation And (HillSave Or SaveSoup=1) Then Gosub LoadSoup '1.01e1

'----- Start evolution cycle
DO

StageOneRatio=0

'----- Read and actuallize the age of the hill ----
Open "age.ini" FOR INPUT AS #1
INPUT #1,readout
HillAge=Val(readout)+1
Close #1
Open "age.ini" FOR output AS #1
Print #1, HillAge
Close #1

'----- Read "in-evolution" ini-file with data

SoupRounds = 0 '1.02x2 - default soup rounds to BattleEvoRounds if not specified

Open "Maezumo.ini" For Input As #1
Do
	Input #1, ReadOut
	IF LEFT(ReadOut,12)="name       :" THEN WarriorSeed=Right(ReadOut,Len(ReadOut)-12)
	IF LEFT(ReadOut,12)="evo rounds :" THEN BattleEvoRounds=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="hill rounds:" THEN BattleRounds=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="threshold  :" THEN BattleThreshold=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="advance    :" THEN BattleAdvance=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="spl        :" THEN ProbSpl=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="mov        :" THEN ProbMov=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="add        :" THEN ProbAdd=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="sne        :" THEN ProbSne=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="seq        :" THEN ProbSeq=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="djn        :" THEN ProbDjn=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="jmn        :" THEN ProbJmn=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="jmz        :" THEN ProbJmz=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="jmp        :" THEN ProbJmp=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="hill freeze:" THEN HillFreeze=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="No of koth :" THEN KothNumber=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="Mutation   :" THEN EnableMutation=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="MutSelect  :" THEN MutationSelect=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="MinChanges :" THEN MinChanges=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="MutRate    :" THEN MutationRate=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="InstrRate  :" THEN InstrRate=Val(Right(ReadOut,Len(ReadOut)-12))*MutationRate
	IF LEFT(ReadOut,12)="AddrRate   :" THEN AddrRate=Val(Right(ReadOut,Len(ReadOut)-12))*MutationRate
	IF LEFT(ReadOut,12)="DataRate   :" THEN DataRate=Val(Right(ReadOut,Len(ReadOut)-12))*MutationRate
	IF LEFT(ReadOut,12)="InsertRate :" THEN InsertRate=Val(Right(ReadOut,Len(ReadOut)-12))*MutationRate
	IF LEFT(ReadOut,12)="DeleteRate :" THEN DeleteRate=Val(Right(ReadOut,Len(ReadOut)-12))*MutationRate
	IF LEFT(ReadOut,12)="DupLine    :" THEN DupLineChance=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="IncDec     :" THEN IncDecChance=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="BigNum     :" THEN BigNumChance=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="MutByProb  :" THEN MutateByProbability=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="dat        :" THEN ProbDat=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="SoupIter   :" THEN SoupIterations=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="SaveSoup   :" THEN SaveSoup=Val(Right(ReadOut,Len(ReadOut)-12))
	IF LEFT(ReadOut,12)="ShowExtra  :" THEN ShowExtra=Val(Right(ReadOut,Len(ReadOut)-12))  '1.01e1
	IF LEFT(ReadOut,12)="SoupRounds :" THEN SoupRounds=Val(Right(ReadOut,Len(ReadOut)-12)) '1.01e1
	IF LEFT(ReadOut,12)="EnableSeed :" THEN EnableSeed=Val(Right(ReadOut,Len(ReadOut)-12)) '1.02x3
	IF LEFT(ReadOut,12)="SoupDisplay:" THEN SoupDisplay=Val(Right(ReadOut,Len(ReadOut)-12)) '1.02x3
	IF LEFT(ReadOut,12)="SwapRate   :" THEN SwapRate=Val(Right(ReadOut,Len(ReadOut)-12))*MutationRate '1.02x3
	IF LEFT(ReadOut,12)="SW Display :" THEN EnableSW=Val(Right(ReadOut,Len(ReadOut)-12))    '1.02x4
	IF LEFT(ReadOut,12)="SDcustom   :" THEN SDcustom=Right(ReadOut,Len(ReadOut)-12)         '1.03x5
	IF LEFT(ReadOut,12)="SoupWins   :" THEN SoupWins=Val(Right(ReadOut,Len(ReadOut)-12))    '1.02x6
	IF LEFT(ReadOut,12)="hint-pur   :" THEN HintProb (0)=Val(Right(ReadOut,Len(ReadOut)-12))'1.04cs
	IF LEFT(ReadOut,12)="hint-pap   :" THEN HintProb (1)=Val(Right(ReadOut,Len(ReadOut)-12))'1.04cs
	IF LEFT(ReadOut,12)="hint-sca   :" THEN HintProb (2)=Val(Right(ReadOut,Len(ReadOut)-12))'1.04cs
	IF LEFT(ReadOut,12)="hint-fra   :" THEN HintProb (3)=Val(Right(ReadOut,Len(ReadOut)-12))'1.04cs
	IF LEFT(ReadOut,12)="hint-sto   :" THEN HintProb (4)=Val(Right(ReadOut,Len(ReadOut)-12))'1.04cs
	IF LEFT(ReadOut,12)="Embedding  :" THEN EmbeddingOn=Val(Right(ReadOut,Len(ReadOut)-12)) '1.05cs
	IF LEFT(ReadOut,12)="ReInsMode  :" THEN ReInsMode=Val(Right(ReadOut,Len(ReadOut)-12))   '1.04x8
	IF LEFT(ReadOut,12)="ReInsChance:" THEN ReInsChance=Val(Right(ReadOut,Len(ReadOut)-12)) '1.04x8
	IF LEFT(ReadOut,12)="TakeOver   :" THEN TakeOver=Val(Right(ReadOut,Len(ReadOut)-12)) '1.06cs
	IF LEFT(ReadOut,12)="TakePerc   :" THEN TakePerc=Val(Right(ReadOut,Len(ReadOut)-12)) '1.06cs
	IF LEFT(ReadOut,12)="RItopPerc  :" THEN RItopPerc=Val(Right(ReadOut,Len(ReadOut)-12)) '1.06x14
	IF LEFT(ReadOut,12)="DisplayTS  :" THEN DisplayTS=Val(Right(ReadOut,Len(ReadOut)-12)) '1.06x15

Loop Until Eof (1)
Close #1

'1.05x9 - additional error checking for modifiable parameters
'These don't interrupt the run but default and print error message
TempInt2 = 0 
If HintMode=9 Then EnableMutation=0 'deactivate mutation for HintMode 9 1.10
If HillFreeze > HillSize-2 Then TempInt2 = 1 : HillFreeze = HillSize-2
If KothNumber > HillSize-1 Then TempInt2 = 1 : KothNumber = HillSize-1
If BattleEvoRounds < 1 Then TempInt2 = 1 : BattleEvoRounds = 50
If BattleRounds < 1 Then TempInt2 = 1 : BattleRounds = 50
If TempInt2 Then Print "Check hill parameters"

If SoupRounds=0 Then SoupRounds=BattleEvoRounds '1.02x2

CounterImp=(CoreSize+1)/(3+Int(Rnd*2)*2)'1.04cs
HillBattleNo=(BattleRounds*(HillSize-1))/100
BattleEvoCommand=Mars+" -s "+Str(CoreSize)+" -c "+Str(MaxCycle)+" -l "+Str(MaxLen)+" -d "+Str(MinDist)+" -b -k -r "+Str(BattleEvoRounds)
BattleCommand=Mars+" -s "+Str(CoreSize)+" -c "+Str(MaxCycle)+" -l "+Str(MaxLen)+" -d "+Str(MinDist)+" -b -k -r "+Str(BattleRounds)
SoupCommand=Mars+" -s "+Str(CoreSize)+" -c "+Str(MaxCycle)+" -l "+Str(MaxLen)+" -d "+Str(MinDist)+" -b -k -r "+Str(SoupRounds)

'----- Read in filenames from banzuke.txt -----
CounterA = 0
CounterB = 0
Open "warrior.ini" FOR INPUT AS #1
Do
	CounterA = CounterA + 1
   INPUT #1,WarriorFile(CounterA)
Loop Until Eof (1)
CLOSE #1

'---- Extract Name, Author and Type from each file ----
Do
	CounterB = CounterB + 1
	Open WarriorFile(CounterB) For input As #1
	Input #1, ReadOut
   WarriorType(CounterB)="Evo" 'reserved
	HillOrigin(CounterB) = ""    '1.01e1
	HillGenCount(CounterB) = 0   '1.01e1
	HillBenchScore(CounterB) = 0 '1.01e1
   For CounterC=0 To 10
		Input #1, ReadOut
		IF LEFT(ReadOut,6)=";name " THEN WarriorName(CounterB)=Right(ReadOut,Len(ReadOut)-6)
		IF LEFT(ReadOut,8)=";author " THEN WarriorAuthor(CounterB)=Right(ReadOut,Len(ReadOut)-8)
		IF LEFT(ReadOut,8)=";origin " THEN HillOrigin(CounterB)=Right(ReadOut,Len(ReadOut)-8) '1.01e1
		IF LEFT(ReadOut,12)=";generation " THEN HillGenCount(CounterB)=Val(Right(ReadOut,Len(ReadOut)-12)) '1.01e1
		IF LEFT(ReadOut,12)=";benchscore " THEN HillBenchScore(CounterB)=Val(Mid(ReadOut,13,6)) '1.01e1
   Next CounterC
   Close #1
	IF WarriorName(CounterB)="" Then
		WarriorName(CounterB)="N/A"
		Print "Warrior:";WarriorFile(CounterB);" has no name"
	End If
	IF WarriorName(CounterB)="" THEN
		WarriorName(CounterB)="N/A"
		Print "Warrior:";WarriorFile(CounterB);" has no author"
	End If
Loop Until CounterB=HillSize


'################### Evolve a warrior ###############################################

'*** Start Loop for Stage 1
Do
StageOneRatio=StageOneRatio+1
CounterEvoLen=1

'1.04cs - Change of probability between the different modes


If IniHintMode = 7 Then

	'Anti-"Take Over" Feature - 1.06cs
	'if a strategy becomes too dominant the probability will automatically set to 0
	If TakeOver then	
		For CounterA=0 To 4
			CounterX(CounterA)=0	
		Next
		For CounterA=1 To HillSize-1
			If Left(HillOrigin(CounterA),3)="Pur" Then CounterX(0)=CounterX(0)+1
			If Left(HillOrigin(CounterA),3)="Pap" Then CounterX(1)=CounterX(1)+1
			If Left(HillOrigin(CounterA),3)="Sca" Then CounterX(2)=CounterX(2)+1
			If Left(HillOrigin(CounterA),3)="Fra" Then CounterX(3)=CounterX(3)+1
			If Left(HillOrigin(CounterA),3)="Sto" Then CounterX(4)=CounterX(4)+1
		Next 
		If TakeOver=1 Then
			For CounterA=0 To 4
			If CounterX(CounterA)>(HillSize-1)*TakePerc/100 Then HintProb (CounterA)=0
			Next 
		EndIf
		If TakeOver=2 And CounterX(1)<(HillSize-1)*TakePerc/100 Then
			HintProb (0)=0
			HintProb (2)=0
			HintProb (3)=0
			HintProb (4)=0
		EndIf
	EndIf 'end takeover mod
 
	CounterA=Int(Rnd*(HintProb (0)+HintProb (1)+HintProb (2)+HintProb (3)+HintProb (4)))
	CounterB=HintProb (0)+HintProb (1)+HintProb (2)+HintProb (3)+HintProb (4)
	If CounterA<=HintProb (0) Then HintMode =0 'pure
	If CounterA>HintProb (0) And CounterA<=(HintProb (0)+HintProb (1)) Then HintMode =1 'paper
	If CounterA>(HintProb (0)+HintProb (1)) And CounterA<=(HintProb (0)+HintProb (1)+HintProb (2)) Then HintMode =2 'scanner
	If CounterA>(HintProb (0)+HintProb (1)+HintProb (2)) And CounterA<=(CounterB-HintProb (4)) Then HintMode =3 'fragment
	If CounterA>(CounterB-HintProb (4)) Then HintMode =4 'stone
EndIf 

If IniHintMode = 8 Then HintMode = Int(Rnd*2+1) 'paper or scanner

'1.01e1 - major change - mutation is now available for all hints,
'previously pure had to be selected to use mutation.

If EnableMutation Then If Rnd < MutationSelect Then Gosub MutateFromSoup

'if a mutated warrior is not selected then CounterEvoLen will remain 1
'extra condition "And CounterEvoLen = 1" added to all hint triggers

'------->1.05cs Start

'*** generating Paper v1.06cs
If HintMode=1 And CounterEvoLen = 1 Then
'pre-code
	If Int(Rnd*10)>7 And Evolen>=CounterEvoLen+1 Then GoSub SecondPartSoupGen

	CounterA=Int(Rnd*13)

	'Evo-style complete
	If CounterA>8 And CounterA<=10 Then
		If Evolen>=CounterEvoLen+3 Then GoSub FirstPartEvoPaperGen
		If Evolen>=CounterEvoLen+2 And (Rnd*4)>2 Then GoSub FirstPartSoupGen2
		If EvoLen>=CounterEvoLen+1 And (Rnd*4)>2 Then GoSub SecondPartSoupGen2	
	EndIf
	
	'LP-style complete
	If CounterA>10 Then
	If Evolen>=CounterEvoLen+1 Then GoSub FirstPartLPPaperGen
	If EvoLen>=CounterEvoLen+1 And (Rnd*4)>2 Then GoSub SecondPartSoupGen2
	If Evolen>=CounterEvoLen+4 Then GoSub SecondPartLPPaperGen		
	EndIf
	
	'Silk style paper
	If CounterA<=8 Then
	'first part	
		If Evolen>=CounterEvoLen+2 Then GoSub FirstParallelGen
		If Evolen>=CounterEvoLen+4 And (Rnd*4)>2 Then GoSub PaperBootGen
		If Evolen>=CounterEvoLen+3 Then GoSub FirstPartPaperGen	
	'second part
		CounterB=Int(Rnd*12)
		If CounterB<=3 Then
			If EvoLen>=CounterEvoLen+1 Then GoSub SecondPartSoupGen2
			If EvoLen>=CounterEvoLen+1 And (Rnd*4)>2 Then GoSub PaperImpGen
		EndIf	
		If CounterB>3 And CounterB<=6 Then
			If EvoLen>=CounterEvoLen+1 And (Rnd*4)>2 Then GoSub SecondPartSoupGen2
			If EvoLen>=CounterEvoLen+2 Then GoSub SecondPartPaperGen
		EndIf	
		If CounterB>6 And CounterB<=9 And EvoLen>=CounterEvoLen+1 Then GoSub FirstPartSoupGen2
		If CounterB>9 And EvoLen>=CounterEvoLen+4 Then GoSub SecondPartPaperAuxGen
	EndIf	
	
	Origin = "Paper "+Str(HillAge-1) '1.01e1
	GenCount = 0 '1.01e1
EndIf

'*** generate scanner
If HintMode=2 And CounterEvoLen = 1 Then
	CounterA=Int(Rnd*4)
	If CounterA=1 And Evolen>=CounterEvoLen+0 Then GoSub ScanPartPreGen 
	If CounterA=2 And Evolen>=CounterEvoLen+1 Then GoSub SecondPartSoupGen
	
	If Evolen>=CounterEvoLen+3 Then GoSub ScanPartScanGen
	
	CounterA=Int(Rnd*10)
	If CounterA>4 And Evolen>=CounterEvoLen+3 Then GoSub ScanPartAttackGen

	CounterA=Int(Rnd*10)
	If CounterA>4 And Evolen>=CounterEvoLen+6 Then GoSub ScanPartEndGen 
	If CounterA<=4 And Evolen>=CounterEvoLen+2 then GoSub FirstPartSoupGen
	
	If EvoLen>=CounterEvoLen+1 Then GoSub LastPartSplDatGen
	Origin = "Scanner "+Str(HillAge-1) '1.01e1
	GenCount = 0 '1.01e1
EndIf

'*** generating pure evolved code

If HintMode=0 And CounterEvoLen = 1 Then
	If Evolen>=CounterEvoLen+2 Then GoSub FirstPartSoupGen
	If EvoLen>=CounterEvoLen+2 Then
		CounterA=Int(Rnd*10)
		If CounterA>4 Then GoSub FirstPartSoupGen	Else GoSub SecondPartSoupGen
	EndIf 
	If EvoLen>=CounterEvoLen Then GoSub LastPartDatGen '1.01
	Origin = "Pure "+Str(HillAge-1) '1.01e1
	GenCount = 0 '1.01e1
EndIf 

'*** generating for fragment mode
If HintMode=3 And CounterEvoLen = 1 Then
	'1.03<----------------Start
	'spl $x, $0
		SpeciesCode(1,CounterEvoLen)=1
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=INT(RND*EvoLen)
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=1
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
	While Evolen>CounterEvoLen
		CounterA=1+Int(Rnd*18)
		If CounterA=1 And Evolen>=CounterEvoLen+2 Then GoSub FirstPartSoupGen
		If CounterA=2 And Evolen>=CounterEvoLen+1 Then GoSub SecondPartSoupGen
		If CounterA=3 And Evolen>=CounterEvoLen+2 Then GoSub FirstParallelGen
		If CounterA=4 And Evolen>=CounterEvoLen+3 Then GoSub FirstPartPaperGen
		If CounterA=5 And Evolen>=CounterEvoLen+3 Then GoSub FirstPartEvoPaperGen
		If CounterA=6 And Evolen>=CounterEvoLen+2 Then GoSub SecondPartPaperGen
		If CounterA=7 And Evolen>=CounterEvoLen+1 Then GoSub LastPartDatGen
		If CounterA=8 And Evolen>=CounterEvoLen+0 Then GoSub ScanPartPreGen
		If CounterA=9 And Evolen>=CounterEvoLen+3 Then GoSub ScanPartScanGen
		If CounterA=10 And Evolen>=CounterEvoLen+3 Then GoSub ScanPartAttackGen
		If CounterA=11 And Evolen>=CounterEvoLen+4 Then GoSub SecondPartPaperAuxGen 'new
		If CounterA=12 And Evolen>=CounterEvoLen+5 Then GoSub ImpGen '1.05
		If CounterA=13 And Evolen>=CounterEvoLen+0 Then GoSub LastPartSplDatGen
		If CounterA=14 And Evolen>=CounterEvoLen+5 Then GoSub StonePartFirstGen 'new 
		If CounterA=15 And Evolen>=CounterEvoLen+1 Then GoSub MiscGen '1.05
		If CounterA=16 And Evolen>=CounterEvoLen+4 Then GoSub PaperBootGen '1.05
		If CounterA=17 And Evolen>=CounterEvoLen+1 Then GoSub FirstPartLPPaperGen '1.06cs
		If CounterA=18 And Evolen>=CounterEvoLen+4 Then GoSub SecondPartLPPaperGen '1.06cs
	Wend
		'1.03<----------------End	
	Origin = "Fragment "+Str(HillAge-1) '1.01e1
	GenCount = 0 '1.01e1
EndIf 

'*** generating for stone mode v1.06cs

If HintMode=4 And CounterEvoLen = 1 Then
	'pre-stone
   CounterA=Int(Rnd*6)
	If CounterA=1 And Evolen>=CounterEvoLen+1 Then GoSub SecondPartSoupGen
	If CounterA>3 And Evolen>=CounterEvoLen+1 Then
		'spl $x, $0
		SpeciesCode(1,CounterEvoLen)=1
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=5+INT(RND*5)
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=1
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
	EndIf
	'stone
	If Evolen>=CounterEvoLen+5 Then GoSub StonePartFirstGen
	If (Rnd*10)>4 And Evolen>=CounterEvoLen+4 Then GoSub StonePartEndGen '1.03
	'imp
	CounterA=Int(Rnd*6)
	If CounterA<3 Then 
		If (Rnd*10)>4 And Evolen>=CounterEvoLen+1 Then GoSub MiscGen
		If Evolen>=CounterEvoLen+5 Then GoSub ImpGen
	EndIf
	If CounterA>=3 Then
		If Evolen>=CounterEvoLen+2 Then GoSub FirstParallelGen
		If CounterA=11 And Evolen>=CounterEvoLen+4 Then GoSub SecondPartPaperAuxGen
	EndIf
	'post-stone
	If EvoLen>=CounterEvoLen+1 And (Rnd*10)>7 Then GoSub LastPartSplDatGen '1.06

	Origin = "Stone "+Str(HillAge-1) '1.01e1
	GenCount = 0 '1.01e1
EndIf 

'<-------1.05cs End

If HintMode=9 Then CounterEvoLen=EvoLen '1.10

'*** fill the code with dat's

While EvoLen+1>CounterEvoLen
	SpeciesCode(1,CounterEvoLen)=10
	SpeciesCode(2,CounterEvoLen)=1
	SpeciesCode(3,CounterEvoLen)=0
	SpeciesCode(4,CounterEvoLen)=1
	SpeciesCode(5,CounterEvoLen)=0
	SpeciesCode(6,CounterEvoLen)=0
	SpeciesCode(7,CounterEvoLen)=0
	SpeciesCode(8,CounterEvoLen)=0
	SpeciesCode(9,CounterEvoLen)=0
	CounterEvoLen=CounterEvoLen+1
Wend

'write the code into file
Open WarriorTmpFile FOR OUTPUT AS #1
'header of the warrior
Print #1, ";redcode-";WarriorSeedB
Print #1, ";name ";WarriorSeed;" "+Str(HillAge-1)
Print #1, ";author ";WarriorSeedA
Print #1, ";assert 1"
Print #1, ";evolved with -=< Maezumo >=-" 'changed 1.04cs
Print #1, ";evolved:";Time;" ";Date
Print #1, ";origin ";Origin '1.01e1
Print #1, ";generation ";Str(GenCount) '1.01e1
If EnableBench Then Print #1, ";benchscore (none)" '1.01e1

'write embedding code from embfront.txt

If EmbeddingOn=1 And HintMode<>2 Then 
		Open "files"+PathSym+"embfront.txt" FOR INPUT AS #2
		Do
			Line Input #2, ReadOut
			Print #1, ReadOut
		Loop Until Eof (2)
		Close #2
EndIf


If HintMode<>9 Then '1.10
	
'write evolved code
For CounterA=1 To EvoLen
	Print #1, EvoOpcode(SpeciesCode(1,CounterA));" ";
	Print #1, EvoAdressing(SpeciesCode(2,CounterA));" ";
	Print #1, Str(SpeciesCode(3,CounterA));" ,";
	Print #1, EvoAdressing(SpeciesCode(4,CounterA));" ";
	Print #1, Str(SpeciesCode(5,CounterA))
Next

EndIf '1.10

If HintMode=9 Then
'write EQU's
Open "optimi.ini" For Input As #2
	Do
		Input #2, ReadOut
		IF LEFT(ReadOut,12)="No of const:" THEN OptimiNo=Val(Right(ReadOut,Len(ReadOut)-12))
		IF LEFT(ReadOut,12)="Opt01  name:" THEN OptimiName(1)=Right(ReadOut,Len(ReadOut)-12)
		IF LEFT(ReadOut,12)="Opt01   min:" THEN OptimiMin(1)=Val(Right(ReadOut,Len(ReadOut)-12))
		IF LEFT(ReadOut,12)="Opt01   max:" THEN OptimiMax(1)=Val(Right(ReadOut,Len(ReadOut)-12))
		IF LEFT(ReadOut,12)="Opt02  name:" THEN OptimiName(2)=Right(ReadOut,Len(ReadOut)-12)
		IF LEFT(ReadOut,12)="Opt02   min:" THEN OptimiMin(2)=Val(Right(ReadOut,Len(ReadOut)-12))
		IF LEFT(ReadOut,12)="Opt02   max:" THEN OptimiMax(2)=Val(Right(ReadOut,Len(ReadOut)-12))		
		IF LEFT(ReadOut,12)="Opt03  name:" THEN OptimiName(3)=Right(ReadOut,Len(ReadOut)-12)
		IF LEFT(ReadOut,12)="Opt03   min:" THEN OptimiMin(3)=Val(Right(ReadOut,Len(ReadOut)-12))
		IF LEFT(ReadOut,12)="Opt03   max:" THEN OptimiMax(3)=Val(Right(ReadOut,Len(ReadOut)-12))		
		IF LEFT(ReadOut,12)="Opt04  name:" THEN OptimiName(4)=Right(ReadOut,Len(ReadOut)-12)
		IF LEFT(ReadOut,12)="Opt04   min:" THEN OptimiMin(4)=Val(Right(ReadOut,Len(ReadOut)-12))
		IF LEFT(ReadOut,12)="Opt04   max:" THEN OptimiMax(4)=Val(Right(ReadOut,Len(ReadOut)-12))		
		IF LEFT(ReadOut,12)="Opt05  name:" THEN OptimiName(5)=Right(ReadOut,Len(ReadOut)-12)
		IF LEFT(ReadOut,12)="Opt05   min:" THEN OptimiMin(5)=Val(Right(ReadOut,Len(ReadOut)-12))
		IF LEFT(ReadOut,12)="Opt05   max:" THEN OptimiMax(5)=Val(Right(ReadOut,Len(ReadOut)-12))		
		IF LEFT(ReadOut,12)="Opt06  name:" THEN OptimiName(6)=Right(ReadOut,Len(ReadOut)-12)
		IF LEFT(ReadOut,12)="Opt06   min:" THEN OptimiMin(6)=Val(Right(ReadOut,Len(ReadOut)-12))
		IF LEFT(ReadOut,12)="Opt06   max:" THEN OptimiMax(6)=Val(Right(ReadOut,Len(ReadOut)-12))		
		IF LEFT(ReadOut,12)="Opt07  name:" THEN OptimiName(7)=Right(ReadOut,Len(ReadOut)-12)
		IF LEFT(ReadOut,12)="Opt07   min:" THEN OptimiMin(7)=Val(Right(ReadOut,Len(ReadOut)-12))
		IF LEFT(ReadOut,12)="Opt07   max:" THEN OptimiMax(7)=Val(Right(ReadOut,Len(ReadOut)-12))		
		IF LEFT(ReadOut,12)="Opt08  name:" THEN OptimiName(8)=Right(ReadOut,Len(ReadOut)-12)
		IF LEFT(ReadOut,12)="Opt08   min:" THEN OptimiMin(8)=Val(Right(ReadOut,Len(ReadOut)-12))
		IF LEFT(ReadOut,12)="Opt08   max:" THEN OptimiMax(8)=Val(Right(ReadOut,Len(ReadOut)-12))		
		IF LEFT(ReadOut,12)="Opt09  name:" THEN OptimiName(9)=Right(ReadOut,Len(ReadOut)-12)
		IF LEFT(ReadOut,12)="Opt09   min:" THEN OptimiMin(9)=Val(Right(ReadOut,Len(ReadOut)-12))
		IF LEFT(ReadOut,12)="Opt09   max:" THEN OptimiMax(9)=Val(Right(ReadOut,Len(ReadOut)-12))		
		IF LEFT(ReadOut,12)="Opt10  name:" THEN OptimiName(10)=Right(ReadOut,Len(ReadOut)-12)
		IF LEFT(ReadOut,12)="Opt10   min:" THEN OptimiMin(10)=Val(Right(ReadOut,Len(ReadOut)-12))
		IF LEFT(ReadOut,12)="Opt10   max:" THEN OptimiMax(10)=Val(Right(ReadOut,Len(ReadOut)-12))		
	Loop Until Eof (2)
Close #2	
	
	For CounterF=1 To OptimiNo
		Print #1, OptimiName (CounterF);" EQU "; OptimiMin(CounterF)+INT(RND*(OptimiMax(CounterF)-OptimiMin(CounterF)))
	Next

'write warrior body from optim.txt
		Open "files"+PathSym+"optimi.txt" FOR INPUT AS #2
		Do
			Line Input #2, ReadOut
			Print #1, ReadOut
		Loop Until Eof (2)
		Close #2
EndIf

'write embedding code from embfront.txt
If EmbeddingOn=1 And HintMode<>2 Then 
		Open "files"+PathSym+"embback.txt" FOR INPUT AS #2
		Do
			Line Input #2, ReadOut
			Print #1, ReadOut
		Loop Until Eof (2)
		Close #2
EndIf

Print #1, "end"
CLOSE #1


'------Stage 1--- test against first place
WarriorName(HillSize)=WarriorSeed+" "+Str(HillAge-1)
WarriorAuthor(HillSize)=WarriorSeedA



If KothNumber>1 And KothNumber<=HillSize Then CounterA=1+Int(Rnd*KothNumber) Else CounterA=1
'*** run exmars
BattleF = MaxLen+MinDist+Int(Rnd*(CoreSize-(MaxLen+MinDist)*2)) '1.02x2
TempStoreTxt=BattleEvoCommand+" -p "+Str(MaxProcesses)+" -F "+Str(BattleF)+" "+WarriorTmpFile+" "+WarriorFile(CounterA)
If UseWin Then
 SHELL TempStoreTxt+" >scores.tmp"
 OPEN "scores.tmp" FOR INPUT AS #1
Else
 OPEN PIPE TempStoreTxt FOR INPUT AS #1
EndIf

'*** read the results
CounterD=0
INPUT #1,ReadOut
CLOSE #1
ReadOut=ReadOut+" "
Do
CounterD = CounterD+1
Loop Until MID$(ReadOut,CounterD,1)=" "
BattleWin=VAL(LEFT$(ReadOut,CounterD-1))
BattleTie=VAL(RIGHT$(ReadOut,LEN(ReadOut)-CounterD))
BattleLoss=BattleEvoRounds-BattleWin-BattleTie

'sometimes for small coresize problems appears, this should solve it
'If BattleWin=BattleEvoRounds And HillAge>HillSize Then BattleWin=0
'If BattleWin=BattleTie And BattleLoss=0 And HillAge>HillSize Then BattleWin=0

'1.04x8 Valhalla code... re-insert hill warriors back into soup
'ReInsMode 0 = off, 1 = random pick, 2 = KOTH, 3 = high-scoring hill, 4 = top.red
'ReInsMode 5 = from species instead of hill (1.06x14)
' option 5 was interesting but no pressure to perform well on benchmarks
' so added RItopPerc setting to only select high-scoring warriors
'ReInsChance determines frequency of reinsertion per hill age, 0 to 1
'(influence also determined by SoupIter and SoupSize)
If EnableMutation And ReInsMode > 0 Then
 If Rnd < ReInsChance Then
  SoupEntry = Int(Rnd*SoupSize)+1
  HillEntry = Int(Rnd*(HillSize-HillFreeze-1))+HillFreeze+1 '1.05x9
  If ReInsMode = 2 Then HillEntry = HillFreeze+1  '1.05x9
  If ReInsMode = 3 And EnableBench Then
   J = 0 'best score
   For I = HillFreeze+1 To HillSize-1  '1.05x9
    If HillBenchScore(I) > J Then
     If Rnd < 0.5 Then
      J = HillBenchScore(I)
      HillEntry = I
     EndIf
    EndIf
   Next I
  EndIf
  WarFilename = WarriorFile(HillEntry)
  If ReInsMode = 4 And EnableBench Then WarFilename = "topscore.red"  '1.05x10
  If ReInsMode = 5 And HillSave Then 'new mode for 1.06x14...
   WarFilename = "" 'default to no insertion
   CounterA = 0  'number of warriors in species
   CounterB = 0  'number of tries to find a suitable warrior
   TempStoreTxt = Dir("species"+PathSym+"*.red")
   If TempStoreTxt <> "" Then 'if warriors in species directory
    Do 'count number of warriors in species...
     CounterA = CounterA + 1
     TempStoreTxt = Dir()
    Loop Until TempStoreTxt = ""
    Do 'try to find a warrior to reinsert
     CounterB = CounterB + 1
     J = Int(Rnd * CounterA) + 1 'randomly choose a warrior
     WarFilename = Dir("species"+PathSym+"*.red")
     If J > 1 Then
      For I = 2 To J
       WarFilename = Dir()
      Next I
     EndIf
     WarFilename = "species"+PathSym+WarFilename
     TempStoreInt = Open(WarFilename,For Input,As #1)
     If TempStoreInt Then 'error opening
      WarFilename = ""
     Else
      Origin = ""
      BenchScore = TopScore 'defaults to mode 5 behavior if no benchmarking
      While Not Eof(1)
       Line Input #1, TempStoreTxt
       If Left(TempStoreTxt,8)=";origin " Then Origin=Mid(TempStoreTxt,9)
       If Left(TempStoreTxt,12)=";benchscore " Then BenchScore=Val(Mid(TempStoreTxt,13,6))
      Wend
      Close #1
      If HintProb(0) = 0 And Left(Origin,4)="Pure" Then WarFilename=""
      If HintProb(1) = 0 And Left(Origin,5)="Paper" Then WarFilename=""
      If HintProb(2) = 0 And Left(Origin,7)="Scanner" Then WarFilename=""
      If HintProb(3) = 0 And Left(Origin,8)="Fragment" Then WarFilename=""
      If HintProb(4) = 0 And Left(Origin,5)="Stone" Then WarFilename=""
      If (BenchScore + 0.001) < (TopScore * (RItopPerc / 100)) Then WarFilename=""
     EndIf
    Loop While WarFilename = "" And CounterB < HillAge '1.06x14 (was 5 tries)
   EndIf 'species warriors present
  EndIf 'mode 5
  If WarFilename <> "" Then '1.06x14 to permit ignoring insertion
   Print "Copying ";WarFilename;" to soup position ";Str(SoupEntry)
   Gosub LoadSoupWarrior
  EndIf
 EndIf
EndIf

'*** stop routine
If INKEY = "q" Then
   Gosub CheckAndSaveSoup
	Print "Evolution is stopped"
	Print "Press any key to exit" '1.01
	Sleep
	End
EndIf
'*** ------------

Loop Until (BattleWin-BattleLoss)>BattleAdvance And BattleWin>BattleThreshold


Print "After ";StageOneRatio;" evolution cycles species #";HillAge-1;" will be benchmarked"

Kill WarriorFile(HillSize)
WarriorFile(HillSize)=WarriorSeed+Str(HillAge-1)+".red"
Name WarriorTmpFile, WarriorFile(HillSize)

AllSpecies=AllSpecies+StageOneRatio

Open "evo.ini" FOR output AS #1
Print #1, AllSpecies
Close #1

'---- Run Stage 2 - the Benchmark ----
CounterA = 0
CounterB = 0

FOR CounterA=2 TO HillSize
FOR CounterB=1 TO CounterA-1
CounterD=0

'*** run exmars
BattleF = MaxLen+MinDist+Int(Rnd*(CoreSize-(MaxLen+MinDist)*2)) '1.02x2
TempStoreTxt=BattleCommand+" -p "+Str(MaxProcesses)+" -F "+Str(BattleF)+" "+WarriorFile(CounterA)+" "+WarriorFile(CounterB)
If UseWin Then
 SHELL TempStoreTxt+" >scores.tmp"
 OPEN "scores.tmp" FOR INPUT AS #1
Else
 OPEN PIPE TempStoreTxt FOR INPUT AS #1
EndIf

'*** read the results
INPUT #1,ReadOut
CLOSE #1
ReadOut=ReadOut+" "
Do
CounterD = CounterD+1
Loop Until MID$(ReadOut,CounterD,1)=" "
BattleWin=VAL(LEFT$(ReadOut,CounterD-1))
BattleTie=VAL(RIGHT$(ReadOut,LEN(ReadOut)-CounterD))
BattleLoss=BattleRounds-BattleWin-BattleTie

WarriorWin(CounterA)=WarriorWin(CounterA)+BattleWin
WarriorTie(CounterA)=WarriorTie(CounterA)+BattleTie
WarriorLoss(CounterA)=WarriorLoss(CounterA)+BattleLoss
WarriorWin(CounterB)=WarriorWin(CounterB)+BattleLoss
WarriorTie(CounterB)=WarriorTie(CounterB)+BattleTie
WarriorLoss(CounterB)=WarriorLoss(CounterB)+BattleWin

WarriorResult(CounterA)=WarriorResult(CounterA)+(BattleWin*3)+BattleTie
WarriorResult(CounterB)=WarriorResult(CounterB)+(BattleLoss*3)+BattleTie

'Show results on monitor
If CounterA=HillSize Or CounterB=HillSize Then Print WarriorName(CounterA);"	";BattleWin;"	";BattleTie;"	";BattleLoss;"	";WarriorName(CounterB)
'----------

NEXT CounterB
NEXT CounterA


'---- scores for arranging the new banzuke
FOR CounterA=1 TO HillSize
	WarriorScoring(CounterA)=WarriorResult(CounterA)
NEXT CounterA 

ReadOut2=WarriorName(HillSize)

'remember the actual warrior for the hill save option
ReadOut3=WarriorFile(HillSize)

'---- Sort the results
FOR CounterA=HillFreeze+1 TO HillSize
FOR CounterB=CounterA+1 TO HillSize
	
IF WarriorScoring(CounterA)<WarriorScoring(CounterB) THEN

TempStoreTxt=WarriorFile(CounterA)
WarriorFile(CounterA)=WarriorFile(CounterB)
WarriorFile(CounterB)=TempStoreTxt

TempStoreTxt=WarriorName(CounterA)
WarriorName(CounterA)=WarriorName(CounterB)
WarriorName(CounterB)=TempStoreTxt

TempStoreTxt=WarriorAuthor(CounterA)
WarriorAuthor(CounterA)=WarriorAuthor(CounterB)
WarriorAuthor(CounterB)=TempStoreTxt

TempStoreTxt=WarriorType(CounterA)
WarriorType(CounterA)=WarriorType(CounterB)
WarriorType(CounterB)=TempStoreTxt

TempStoreInt=WarriorResult(CounterA)
WarriorResult(CounterA)=WarriorResult(CounterB)
WarriorResult(CounterB)=TempStoreInt

TempStoreSing=WarriorScoring(CounterA)
WarriorScoring(CounterA)=WarriorScoring(CounterB)
WarriorScoring(CounterB)=TempStoreSing

TempStoreSing=WarriorWin(CounterA)
WarriorWin(CounterA)=WarriorWin(CounterB)
WarriorWin(CounterB)=TempStoreSing

TempStoreSing=WarriorTie(CounterA)
WarriorTie(CounterA)=WarriorTie(CounterB)
WarriorTie(CounterB)=TempStoreSing

TempStoreSing=WarriorLoss(CounterA)
WarriorLoss(CounterA)=WarriorLoss(CounterB)
WarriorLoss(CounterB)=TempStoreSing

'new sorts for 1.01e1...
TempStoreTxt=HillOrigin(CounterA)
HillOrigin(CounterA)=HillOrigin(CounterB)
HillOrigin(CounterB)=TempStoreTxt
TempStoreInt=HillGenCount(CounterA)
HillGenCount(CounterA)=HillGenCount(CounterB)
HillGenCount(CounterB)=TempStoreInt
TempStoreSing=HillBenchScore(CounterA)
HillBenchScore(CounterA)=HillBenchScore(CounterB)
HillBenchScore(CounterB)=TempStoreSing


EndIf

NEXT CounterB
NEXT CounterA

'1.01e1a ---- Benchmark successful warriors
BenchScore = 0
If EnableBench And ReadOut3<>WarriorFile(HillSize) Then
 CounterA = 0
 CounterB = 0
 Do
   CounterB = CounterB + 1
   BenchWarrior = Dir (BenchDir + PathSym + BenchMask(CounterB))
 Loop Until BenchWarrior <> "" Or CounterB = NumBenchMasks
 If BenchWarrior = "" Then
   Print "(bench warriors removed, disabling benchmarking)"
   EnableBench = 0 : BenchScore = 0
 Else
  Do
   BenchWarrior = BenchDir + PathSym + BenchWarrior
   CounterA = CounterA + 1
   BattleF = Int(CoreSize/2)
   TempStoreTxt=BattleCommand+" -p "+Str(MaxProcesses)+" -F "+Str(BattleF)+" "+ReadOut3+" "+BenchWarrior
   If UseWin Then
    SHELL TempStoreTxt+" >scores.tmp"
    OPEN "scores.tmp" FOR INPUT AS #1
   Else
    OPEN PIPE TempStoreTxt FOR INPUT AS #1
   EndIf
   INPUT #1,ReadOut
   CLOSE #1
   ReadOut=ReadOut+"  "
   TempStoreInt=Instr(ReadOut," ")
   BattleWin=Val(Left(ReadOut,TempStoreInt))
   BattleTie=Val(Mid(ReadOut,TempStoreInt))
   BenchScore=BenchScore + BattleWin * 3 + BattleTie
   BenchWarrior = Dir ()
   If BenchWarrior = "" And CounterB < NumBenchMasks Then
    Do
     CounterB = CounterB + 1
     BenchWarrior = Dir (BenchDir + PathSym + BenchMask(CounterB))
    Loop Until BenchWarrior <> "" Or CounterB = NumBenchMasks
   EndIf  
  Loop While BenchWarrior <> "" 
  BenchScore = (BenchScore / CounterA) * (100 / BattleRounds)
'add bench score to warrior
  Open ReadOut3 For Input As #1
  Open "warrior.tmp" For Output As #2
  While Not EOF(1)
   Line Input #1,ReadOut
   If Left(ReadOut,12)=";benchscore " Then
    ReadOut=";benchscore "+Left(Str(BenchScore)+"     ",6)+" ("+BenchDirName+" "+Str(BattleRounds)+" rounds)"
   EndIf
   Print #2,ReadOut
  Wend
  Close #1 : Close #2
  Open "warrior.tmp" For Input As #1   'copy back to original file to
  Open ReadOut3 For Output As #2       'avoid extra disk access
  While Not EOF(1)
   Line Input #1,ReadOut : Print #2,ReadOut
  Wend
  Close #1 : Close #2 : Kill "warrior.tmp"
  Print "Bench score = ";Str(BenchScore);"  ";Origin;" Gen ";Str(GenCount) '1.04x8
  If BenchScore > TopScore Then  '1.05x10
   FileCopy (ReadOut3, "topscore.red")
   TopScore = BenchScore + 0.0001
  EndIf
 EndIf
EndIf
'figure out which warrior it is to record score, origin and generation
For CounterC=1 To HillSize
 If ReadOut3=WarriorFile(CounterC) Then
  HillBenchScore(CounterC)=BenchScore
  HillOrigin(CounterC)=Origin
  HillGenCount(CounterC)=GenCount
 EndIf
Next

'---- Save successful warriors into the species directory
If HillSave Then  '1.01e1 (logic-proofing)
	If ReadOut3<>WarriorFile(HillSize) Then
		TempStoreTxt="species"+PathSym+ReadOut3
		FileCopy (ReadOut3, TempStoreTxt)
	EndIf
EndIf

'save warrior to soup array if it made the hill
If EnableSeed Then '1.02x3
 If ReadOut3<>WarriorFile(HillSize) Then
  SoupEntry = Int(Rnd*SoupSize+1)
  SoupOrigin(SoupEntry) = Origin '1.01e1
  SoupGenCount(SoupEntry) = GenCount '1.01e1
  For I = 1 To 5
   For J = 1 To EvoLen
    SoupCode(SoupEntry,I,J) = SpeciesCode(I,J)
   Next
  Next
 EndIf
EndIf

'---- Store new ranking to file
open "warrior.ini" for output as #1
FOR CounterA=1 TO HillSize
PRINT #1, WarriorFile(CounterA)

NEXT CounterA
CLOSE #1

'---- write the basho results into a html ******************************************* 

WarriorCell = ""
LineHeight = ""   '1.04x7
If SoupDisplay = 1 Then WarriorCell = "O"  'normal cell display
If SoupDisplay = 2 Then WarriorCell = "&#9609;" 'narrow blocks
If SoupDisplay = 3 Then WarriorCell = "&#9608;&#9610;" 'wide blocks
If SoupDisplay = 4 Then WarriorCell = "&#11042;" 'hex
If SoupDisplay = 5 Then WarriorCell = SDcustom '1.02x4 user-specified
If SoupDisplay = 5 Then LineHeight=" style="+Chr(34)+"line-height:0.85;"+Chr(34) '1.04x7

If WarriorCell = "" Then SoupDisplay = 0

open "indexhtm.tmp" for output as #3  '1.03x6 write to temp instead

'add header
Open "files"+PathSym+"header.ini" For Input As #1
do
Input #1, ReadOut
Print #3, Readout
Loop Until Eof (1)
Close #1
'------Generate the Settings table------------------
Print #3,  "<table align=left cols=2 border=1 cellpadding=3><tbody align=right>"
Print #3, "<tr bgcolor=#AAAAAA><th>Evolution Modes</th><th></th></tr>"

'<-----1.06
'--------   pur          pap         sca           fra          sto
CounterD=HintProb (0)+HintProb (1)+HintProb (2)+HintProb (3)+HintProb (4)
CounterE=100-(MutationSelect*100*EnableMutation)

Print #3, "<tr><td>pure:</td><td>";
If IniHintMode=0 or IniHintMode=7 Then Print #3, "<b>On</b> (";Str(Int(HintProb(0)*CounterE/CounterD));"%)</td></tr>" Else Print #3, "Off</td></tr>"
Print #3, "<tr><td>paper:</td><td>";
If IniHintMode=1 or IniHintMode=7 or IniHintMode=8 Then Print #3, "<b>On</b> (";Str(Int(HintProb(1)*CounterE/CounterD));"%)</td></tr>" Else Print #3, "Off</td></tr>"	 
Print #3, "<tr><td>scanner:</td><td>";
If IniHintMode=2 or IniHintMode=7 or IniHintMode=8 Then Print #3, "<b>On</b> (";Str(Int(HintProb(2)*CounterE/CounterD));"%)</td></tr>" Else Print #3, "Off</td></tr>"	 
Print #3, "<tr><td>stone:</td><td>";
If IniHintMode=4 or IniHintMode=7 Then Print #3, "<b>On</b> (";Str(Int(HintProb(4)*CounterE/CounterD));"%)</td></tr>" Else Print #3, "Off</td></tr>"	 
Print #3, "<tr><td>fragment:</td><td>";'1.04cs
If IniHintMode=3 or IniHintMode=7 Then Print #3, "<b>On</b> (";Str(Int(HintProb(3)*CounterE/CounterD));"%)</td></tr>" Else Print #3, "Off</td></tr>"	 

Print #3, "<tr><td>optimizer:</td><td>";'1.10
If IniHintMode=9 Then Print #3, "<b>On</b></td></tr>" Else Print #3, "Off</td></tr>"	 


Print #3, "<tr><td>mutation:</td><td>"
If EnableMutation Then Print #3, "<b>On</b> (";Str(Int(100-CounterE));"%)</td></tr>" Else Print #3, "Off</td></tr>"
'----->1.06

Print #3, "<tr bgcolor=#AAAAAA><th>Warrior Parameter</th><th></th></tr>"
Print #3, "<tr><td>warrior naming:</td><td>";WarriorSeed;"</td></tr>"
Print #3, "<tr><td>author:</td><td>";WarriorSeedA;"</td></tr>"
Print #3, "<tr><td>type:</td><td>";WarriorSeedB;"</td></tr>"
Print #3, "<tr><td>warrior length:</td><td>";EvoLen;"</td></tr>"
   
Print #3, "<tr bgcolor=#AAAAAA><th>Bench Parameter</th><th></th></tr>"
Print #3, "<tr><td>threshold:</td><td>";BattleThreshold;" wins</td></tr>"
Print #3, "<tr><td>advance:</td><td>";BattleAdvance;" wins</td></tr>"
Print #3, "<tr><td>evolution rounds:</td><td>";BattleEvoRounds;"</td></tr>"
Print #3, "<tr><td>hill freeze:</td><td>Top ";HillFreeze;"</td></tr>"
Print #3, "<tr><td>No. of koth:</td><td>Top ";KothNumber;"</td></tr>"
If EnableBench Then '1.01e1a moved path removing code, use new name var
  Print #3, "<tr><td>Bench Directory:</td><td>";BenchDirName;"</td></tr>"
EndIf
Print #3, "<tr bgcolor=#AAAAAA><th>Hill Parameter</th><th></th></tr>"
Print #3, "<tr><td>coresize:</td><td>";CoreSize;"</td></tr>"
Print #3, "<tr><td>max. processes:</td><td>";MaxProcesses;"</td></tr>"
Print #3, "<tr><td>max. cycle:</td><td>";MaxCycle;"</td></tr>"
Print #3, "<tr><td>max. length:</td><td>";MaxLen;"</td></tr>"
Print #3, "<tr><td>min. distance:</td><td>";MinDist;"</td></tr>"
Print #3, "<tr><td>hill size:</td><td>";HillSize;"</td></tr>"
Print #3, "<tr><td>hill rounds:</td><td>";BattleRounds;"</td></tr>"
Print #3, "<tr><td>hill save:</td><td>"
If HillSave Then Print #3, "<b>On</b></td></tr>" Else Print #3, "Off</td></tr>"	 

Print #3, "<tr bgcolor=#AAAAAA><th>Hill Statistics</th><th></th></tr>"
Print #3, "<tr><td>hill age:</td><td>";HillAge-1;"</td></tr>" 
Print #3, "<tr><td>total evolution cycles:</td><td>";AllSpecies;"</td></tr>" 
Print #3, "<tr><td>cycles per hill age:</td><td>";Str(int(AllSpecies/(HillAge-1)));"</td></tr>" 
      
If EnableMutation Then
  Print #3, "<tr bgcolor=#AAAAAA><th>Soup Parameter</th><th></th></tr>"
  Print #3, "<tr><td>SaveSoup:</td><td>"
  If SaveSoup Then Print #3, "<b>On</b></td></tr>" Else Print #3, "Off</td></tr>"
  Print #3, "<tr><td>Topology:</td><td>";
  If Topology Then Print #3,Topology; Else Print #3,"Grid";
  Print #3, "</td></tr>"
  Print #3, "<tr><td>SoupSize:</td><td>";SoupSize;"</td></tr>"
  Print #3, "<tr><td>SoupIter:</td><td>";SoupIterations;"</td></tr>"
  Print #3, "<tr><td>SoupRounds:</td><td>";SoupRounds;"</td></tr>"
EndIf
   
Print #3, "<tr bgcolor=#AAAAAA><th>Mutation Parameter</th><th></th></tr>"
Print #3, "<tr><td>Mutation:</td><td>"
If EnableMutation Then
  Print #3, "<b>On</b></td></tr>"
  Print #3, "<tr><td>EnableSeed:</td><td>"
  If EnableSeed Then Print #3, "<b>On</b></td></tr>" Else Print #3, "Off</td></tr>"
  If ReInsMode > 0 Then '1.04x8
   Print #3, "<tr><td>ReInsert Mode:</td><td>"
   TempStoreTxt = "Random"
   If ReInsMode = 2 Then TempStoreTxt = "KOTH"
   If ReInsMode = 3 Then TempStoreTxt = "Score"
   If ReInsMode = 4 Then TempStoreTxt = "topscore.red" '1.05x10
   If ReInsMode = 5 Then TempStoreTxt = "Species" '1.06x14
   Print #3, TempStoreTxt;"</td></tr>"
   If ReInsMode = 5 And RItopPerc > 0 Then '1.06x14
    Print #3, "<tr><td>Percent of top score:</td><td>";Str(RItopPerc);"</td></tr>"
   EndIf
   Print #3, "<tr><td>ReInsert Chance:</td><td>";Str(ReInsChance);"</td></tr>"
  EndIf
  Print #3, "<tr><td>MutByProb:</td><td>"
  If MutateByProbability Then Print #3, "<b>On</b></td></tr>" Else Print #3, "Off</td></tr>"
  Print #3, "<tr><td>MutSelect:</td><td>";Str(MutationSelect);"</td></tr>"
  Print #3, "<tr><td>MinChanges:</td><td>";MinChanges;"</td></tr>"
  Print #3, "<tr><td>MutRate:</td><td>";Str(MutationRate);"</td></tr>"
  Print #3, "<tr><td>InstrRate:</td><td>";Str(InstrRate);"</td></tr>"
  Print #3, "<tr><td>AddrRate:</td><td>";Str(AddrRate);"</td></tr>"
  Print #3, "<tr><td>DataRate:</td><td>";Str(DataRate);"</td></tr>"
  Print #3, "<tr><td>SwapRate:</td><td>";Str(SwapRate);"</td></tr>"
  Print #3, "<tr><td>InsertRate:</td><td>";Str(InsertRate);"</td></tr>"
  Print #3, "<tr><td>DeleteRate:</td><td>";Str(DeleteRate);"</td></tr>"
  Print #3, "<tr><td>DupLine:</td><td>";Str(DupLineChance);"</td></tr>"
  Print #3, "<tr><td>IncDec:</td><td>";Str(IncDecChance);"</td></tr>"
  Print #3, "<tr><td>BigNum:</td><td>";Str(BigNumChance);"</td></tr>"
  If MutateByProbability Then Print #3, "<tr><td>dat:</td><td>";ProbDat;"</td></tr>"
Else
  Print #3, "Off</td></tr>"
EndIf

PRINT #3,"</tbody></table>"

'-----Generate the hill table----------------------------------
Print #3, "<table align=left cols=11 border=1 cellpadding=3><tbody align=right>"
Print #3, "<tr bgcolor=#AAAAAA><th>#</th><th>%W</th><th>%L</th><th>%T</th><th>Name</th>";
Print #3, "<th>Author</th><th>Score</th><th>%</th>";
If ShowExtra Then
  Print #3, "<th>Org</th>";
  If EnableMutation Then Print #3, "<th>Gen</th>";
  If EnableBench Then Print #3,"<th>Bench</th>";
EndIf
Print #3, "</tr>"

CounterC=0
Do
  CounterC = CounterC + 1
  PRINT #3, "<tr ";
  If ReadOut2=WarriorName(CounterC) Then PRINT #3, "bgcolor=#FFFF00><td>"; Else PRINT #3, "><td>";
  PRINT #3, Using "##";CounterC;
  PRINT #3, "</td><td>";
  PRINT #3, Using "###.##";(WarriorWin(CounterC)*100)/(BattleRounds*(HillSize-1));
  PRINT #3, "</td><td>";
  PRINT #3, Using "###.##";(WarriorLoss(CounterC)*100)/(BattleRounds*(HillSize-1));
  PRINT #3, "</td><td>";
  PRINT #3, Using "###.##";(WarriorTie(CounterC)*100)/(BattleRounds*(HillSize-1));
  PRINT #3, "</td>";
  If CounterC < HillSize Then
    Print #3, "<td><a href=";WarriorFile(CounterC);">";WarriorName(CounterC);"</a></td>";
  Else
    Print #3, "<td>";WarriorName(CounterC);"</td>";
  EndIf
  Print #3, "<td>";WarriorAuthor(CounterC);"</td>";
  PRINT #3, "<td>";
  PRINT #3, Using "###.##";WarriorResult(CounterC)/HillBattleNo;
  PRINT #3, "</td><td>";
  PRINT #3, Using "###.##";(WarriorResult(CounterC)*100)/WarriorResult(1);

  If ShowExtra Then
    Print #3, "</td><td>";Left(HillOrigin(CounterC)+"???",3);"</td>";
    If EnableMutation Then Print #3, "<td>";Str(HillGenCount(CounterC));
    If EnableBench Then
      Print #3, "</td><td>";
      Print #3, Using "###.##";HillBenchScore(CounterC);
    EndIf
  Endif

  PRINT #3, "</td></tr>"
Loop Until CounterC=HillSize

PRINT #3,"</tbody></table>"

'Display soup... this seems really nutty but to fine tune the mutation
'parameters I need to see how the warrior types are arranged.
'Overall color determined by instruction sequence, colors modified
'by address modes, A values and B values for different shades
If EnableMutation And SoupDisplay > 0 Then   '1.04x7 (bug fix 1.06x16)
 'mod 1.02x4 to display ring soups, display sample soup warrior
 SWposition=Int(Rnd*SoupSize)+1
 Print #3,"<table cols=1 border=1><tbody><tr><td><p><pre";LineHeight;">"  '1.04x7
 CounterD=0
 For CounterC = 1 To SoupSize 
  If CounterD = 0 Then Print #3," ";
  HashI=0 : HashM=0 : HashA=0 : HashB = 0
  If SoupCode(CounterC,1,1) > 0 Then
   For I=1 To EvoLen
    HashI = HashI + SoupCode(CounterC,1,I) * NumberOfInstructions * I
    HashM = HashM + SoupCode(CounterC,2,I) + SoupCode(CounterC,4,I)
    HashA = HashA + SoupCode(CounterC,3,I) + CoreSize
    HashB = HashB + SoupCode(CounterC,5,I) + CoreSize
   Next
  EndIf
  HashI = HashI Mod 1728
  HashM = (HashM Mod 16) + 1
  HashA = (HashA Mod 16) + 1
  HashB = (HashB Mod 16) + 1
  C1 = Int(HashI / 144)
  HashI = HashI - C1 * 144
  C2 = Int(HashI / 12)
  C3 = HashI - C2 * 12
  C1 = (C1 Mod 12) + 1
  C2 = (C2 Mod 12) + 1
  C3 = (C3 Mod 12) + 1
  WarriorColor=Mid(CHexColors,C1,1)+Mid(FHexColors,HashM,1)+Mid(CHexColors,C2,1)
  WarriorColor=WarriorColor+Mid(FHexColors,HashA,1)+Mid(CHexColors,C3,1)+Mid(FHexColors,HashB,1)
  Print #3,"<font color=#";WarriorColor;">";WarriorCell;"</font>";
  If CounterC=SWposition Then SWcolor=WarriorColor
  CounterD=CounterD+1
  If CounterD >= SoupX Then
   Print #3," "
   CounterD=0
  EndIf
 Next
 If CounterD Then Print #3,"" 'new line if not even square soup
 Print #3,"</pre></p></td></tr></tbody></table>"
 '1.02x4 print soup warrior
 If EnableSW Then
  If SoupCode(SWposition,1,1) > 0 Then
   Print #3,"<table cols=1 border=1><tbody><tr><td><p><pre>"
   Print #3," <font color=#";SWcolor;">";WarriorCell;"</font> Soup Warrior ";Str(SWposition);" "
   Print #3," Origin ";SoupOrigin(SWposition) '1.03x6
   Print #3," Generation ";Str(SoupGenCount(SWposition)) '1.03x5
   TempStoreInt=23  '1.03x6 - constant table width according to coresize
   If CoreSize >= 100 Then TempStoreInt=25
   If CoreSize >= 1000 Then TempStoreInt=27
   If CoreSize >= 10000 Then TempStoreInt=29
   Print #3,Space(TempStoreInt)
   For CounterA=1 To EvoLen
    Print #3, "  ";EvoOpcode(SoupCode(SWposition,1,CounterA));" ";
    TempStoreTxt=EvoAdressing(SoupCode(SWposition,2,CounterA))
    If TempStoreTxt="<" Then TempStoreTxt="&lt;"
    If TempStoreTxt=">" Then TempStoreTxt="&gt;"
    Print #3, TempStoreTxt;" ";
    Print #3, Str(SoupCode(SWposition,3,CounterA));" ,";
    TempStoreTxt=EvoAdressing(SoupCode(SWposition,4,CounterA))
    If TempStoreTxt="<" Then TempStoreTxt="&lt;"
    If TempStoreTxt=">" Then TempStoreTxt="&gt;"
    Print #3, TempStoreTxt;" ";
    Print #3, Str(SoupCode(SWposition,5,CounterA));"  "
   Next
   Print #3,"</pre></p></td></tr></tbody></table>"
  EndIf
 EndIf
EndIf

'1.06x15 display top-score warrior
If EnableBench Then
 If TopScore > 0 Then
  If DisplayTS Then
   Print #3,"<table cols=1 border=1><tbody><tr><td><p><pre>"
   Open "topscore.red" For Input As #4
   While Not Eof(4)
    Line Input #4, TempStoreTxt
    Print #3, " ";TempStoreTxt;" ";
    If Not Eof(4) Then Print #3,""
   Wend
   Close #4
   Print #3,"</pre></p></td></tr></tbody></table>"
  EndIf
 EndIf
EndIf

'add footer
Open "files"+PathSym+"footer.ini" For Input As #1
do
Input #1, ReadOut
Print #3, Readout
Loop Until Eof (1)
Close #1
Close #3

FileCopy("indexhtm.tmp","index.htm") '1.03x6
Kill "indexhtm.tmp"

'---- End Program ----
For CounterA=1 To HillSize
WarriorScoring(CounterA)=0
WarriorResult(CounterA)=0
WarriorWin(CounterA)=0
WarriorLoss(CounterA)=0
WarriorTie(CounterA)=0
NEXT CounterA


'end the evolver 
LOOP UNTIL INKEY = "q"
	Gosub CheckAndSaveSoup
	Print "Evolution is stopped"
	Print "Press any key to exit" '1.01
Sleep
End '#####################    END    ######################################
'check-------------\
Print "Checkpoint"'|
Sleep '            |
End '              |
'------------------/	

'*** FirstParallelGen ***********************************************************************************

FirstParallelGen:
CounterC=0
do
	NumLen=2+INT(RND*3)'number of opcodes
Loop Until EvoLen>=CounterEvoLen+NumLen

While NumLen>CounterC
	CounterD=1+INT(RND*6)
	If CounterD=1 Then 'spl $0, }0
		SpeciesCode(1,CounterEvoLen)=1
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=0
		SpeciesCode(4,CounterEvoLen)=7
		SpeciesCode(5,CounterEvoLen)=0
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
	EndIf
	If CounterD=2 Then 'spl $2, _xxx
		SpeciesCode(1,CounterEvoLen)=1
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=2
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
	EndIf
	If CounterD=3 Then 'mov.i $-1, #xxx
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=-1
		SpeciesCode(4,CounterEvoLen)=3
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
	EndIf	
	If CounterD>3 Then 'spl $1, _xxx
		SpeciesCode(1,CounterEvoLen)=1
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=1
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
	EndIf	
CounterC=CounterC+1
Wend
Return

'*** FirstPartPaperGen ***********************************************************************************
FirstPartPaperGen:
CounterC=0
do
	NumLen=1+INT(RND*3)'number of opcodes
Loop Until EvoLen>=CounterEvoLen+(NumLen*3)
'<------------1.04cs start
CounterImp=(CoreSize+1)/(3+Int(Rnd*2)*2)

While NumLen>CounterC
	
	CounterD=1+INT(RND*5)
	If CounterD=1 Then 
		'spl $xxx, $0
		SpeciesCode(1,CounterEvoLen)=1
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(4,CounterEvoLen)=1
		SpeciesCode(5,CounterEvoLen)=0
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=1
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'mov.i   >-1, }-1
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=5
		SpeciesCode(3,CounterEvoLen)=-1
		SpeciesCode(4,CounterEvoLen)=7
		SpeciesCode(5,CounterEvoLen)=-1
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
	EndIf
	If CounterD=2 Then 
		'mov.i {-2 {1
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=6
		SpeciesCode(3,CounterEvoLen)=-2
		SpeciesCode(4,CounterEvoLen)=6
		SpeciesCode(5,CounterEvoLen)=1
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'spl   $xxx, _xxx
		SpeciesCode(1,CounterEvoLen)=1
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=1
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
	EndIf
	If CounterD>2 Then 
		'spl @0, _xxx
		SpeciesCode(1,CounterEvoLen)=1
		SpeciesCode(2,CounterEvoLen)=2
		SpeciesCode(3,CounterEvoLen)=0
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=Int(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		If CounterC>10 Then SpeciesCode(5,CounterEvoLen)=CounterImp+1
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
		'mov.i   }-1, >-1
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=7
		SpeciesCode(3,CounterEvoLen)=-1
		SpeciesCode(4,CounterEvoLen)=5
		SpeciesCode(5,CounterEvoLen)=-1
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		CounterE=Int(Rnd*12)
		If CounterE<3 Then
		'mov.i   }-2, >-2
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=7
		SpeciesCode(3,CounterEvoLen)=-2
		SpeciesCode(4,CounterEvoLen)=5
		SpeciesCode(5,CounterEvoLen)=-2
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		EndIf
		If CounterE>10 And (Rnd*5)<2 Then '1.05
			CounterF=Int(Rnd*16)
			If CounterF<8 Then
				'mov.i   #xxx, Counterimp
				SpeciesCode(1,CounterEvoLen)=2
				SpeciesCode(2,CounterEvoLen)=3
				SpeciesCode(3,CounterEvoLen)=Int(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
				SpeciesCode(4,CounterEvoLen)=1
				SpeciesCode(5,CounterEvoLen)=CounterImp
				SpeciesCode(6,CounterEvoLen)=0
				SpeciesCode(7,CounterEvoLen)=0
				SpeciesCode(8,CounterEvoLen)=0
				SpeciesCode(9,CounterEvoLen)=0
				CounterEvoLen=CounterEvoLen+1
			EndIf
			If CounterF>=8 Then
				'mov.i   #Counterimp,*0
				SpeciesCode(1,CounterEvoLen)=2
				SpeciesCode(2,CounterEvoLen)=3
				SpeciesCode(3,CounterEvoLen)=CounterImp
				SpeciesCode(4,CounterEvoLen)=8
				SpeciesCode(5,CounterEvoLen)=0
				SpeciesCode(6,CounterEvoLen)=0
				SpeciesCode(7,CounterEvoLen)=0
				SpeciesCode(8,CounterEvoLen)=0
				SpeciesCode(9,CounterEvoLen)=0
				CounterEvoLen=CounterEvoLen+1
			EndIf
		EndIf
	EndIf
CounterC=CounterC+1
'------------>1.04cs end
Wend
Return

'*** FirstPartEvoPaperGen ***********************************************************************************

'<-----------1.06 start
FirstPartEvoPaperGen:
	CounterC=1+INT(RND*3)
	If CounterC=1 Then 
		'spl.b   #0, _xxx
		SpeciesCode(1,CounterEvoLen)=1
		SpeciesCode(2,CounterEvoLen)=3
		SpeciesCode(3,CounterEvoLen)=0
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
		'spl.b   $pStep1, _xxx
		SpeciesCode(1,CounterEvoLen)=1
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=1
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
		'mov.i   }-2,  }-1
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=7
		SpeciesCode(3,CounterEvoLen)=-2
		SpeciesCode(4,CounterEvoLen)=7
		SpeciesCode(5,CounterEvoLen)=-1
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
	EndIf
	If CounterC>1 Then 
		'spl.b   #0, _xxx
		SpeciesCode(1,CounterEvoLen)=1
		SpeciesCode(2,CounterEvoLen)=3
		SpeciesCode(3,CounterEvoLen)=0
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
		'mov.i   }-1,  }1
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=7
		SpeciesCode(3,CounterEvoLen)=-1
		SpeciesCode(4,CounterEvoLen)=7
		SpeciesCode(5,CounterEvoLen)=1
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'spl.b   _pStep1, _xxx
		SpeciesCode(1,CounterEvoLen)=1
		SpeciesCode(2,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(3,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=1
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
	EndIf
return
'------------>1.06 end

'*** FirstPartSoupGen ***********************************************************************************
FirstPartSoupGen:
CounterC=0
do
	NumLen=1+INT(RND*5)'number of opcodes
Loop Until EvoLen>=CounterEvoLen+NumLen '1.01


'generate the linear instructions
While NumLen>CounterC
	CounterF=1+Int(Rnd*(ProbSpl+ProbMov+ProbAdd+ProbSne+ProbSeq))
	If CounterF<=ProbSpl Then SpeciesCode(1,CounterEvoLen)=1
	If CounterF>ProbSpl And CounterF <=ProbSpl+(ProbMov/2) Then SpeciesCode(1,CounterEvoLen)=2
	If CounterF>ProbSpl+(ProbMov/2) And CounterF <=ProbSpl+ProbMov Then SpeciesCode(1,CounterEvoLen)=11
	If CounterF>ProbSpl+ProbMov And CounterF <=ProbSpl+ProbMov+ProbAdd Then SpeciesCode(1,CounterEvoLen)=3
	If CounterF>ProbSpl+ProbMov+ProbAdd And CounterF <=ProbSpl+ProbMov+ProbAdd+ProbSne Then SpeciesCode(1,CounterEvoLen)=4		
	If CounterF>ProbSpl+ProbMov+ProbAdd+ProbSne And CounterF <=ProbSpl+ProbMov+ProbAdd+ProbSne+ProbSeq Then SpeciesCode(1,CounterEvoLen)=5
	SpeciesCode(2,CounterEvoLen)=1+INT(RND*8)
	SpeciesCode(3,CounterEvoLen)=INT(RND*((2*EvoTpA(SpeciesCode(1,CounterEvoLen))+1)))-EvoTpA(SpeciesCode(1,CounterEvoLen))
	SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
	SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpA(SpeciesCode(1,CounterEvoLen))+1)))-EvoTpA(SpeciesCode(1,CounterEvoLen))
	SpeciesCode(6,CounterEvoLen)=1
	If EvoTpA(SpeciesCode(1,CounterEvoLen))>EvoLen Then SpeciesCode(7,CounterEvoLen)=1 Else SpeciesCode(7,CounterEvoLen)=0
	SpeciesCode(8,CounterEvoLen)=1
	If EvoTpA(SpeciesCode(1,CounterEvoLen))>EvoLen Then SpeciesCode(9,CounterEvoLen)=1 Else SpeciesCode(9,CounterEvoLen)=0
	CounterEvoLen=CounterEvoLen+1
	CounterC=CounterC+1
Wend

'generate the loop instruction
	CounterF=1+Int(Rnd*(ProbDjn+ProbJmn+ProbJmz+ProbJmp))
	If CounterF<=(ProbDjn/2) Then SpeciesCode(1,CounterEvoLen)=6
	If CounterF>(ProbDjn/2) And CounterF<=ProbDjn Then SpeciesCode(1,CounterEvoLen)=7
	If CounterF>ProbDjn And CounterF <=ProbDjn+ProbJmn Then SpeciesCode(1,CounterEvoLen)=8
	If CounterF>ProbDjn+ProbJmn And CounterF <=ProbDjn+ProbJmn+ProbJmz Then SpeciesCode(1,CounterEvoLen)=12
	If CounterF>ProbDjn+ProbJmn+ProbJmz And CounterF <=ProbDjn+ProbJmn+ProbJmz+ProbJmp Then SpeciesCode(1,CounterEvoLen)=9
   SpeciesCode(2,CounterEvoLen)=1+INT(RND*8)
	SpeciesCode(3,CounterEvoLen)=INT(RND*((2*EvoTpA(SpeciesCode(1,CounterEvoLen))+1)))-EvoTpA(SpeciesCode(1,CounterEvoLen))
	SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
	SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpA(SpeciesCode(1,CounterEvoLen))+1)))-EvoTpA(SpeciesCode(1,CounterEvoLen))
	SpeciesCode(6,CounterEvoLen)=1
	If EvoTpA(SpeciesCode(1,CounterEvoLen))>EvoLen Then SpeciesCode(7,CounterEvoLen)=1 Else SpeciesCode(7,CounterEvoLen)=0
	SpeciesCode(8,CounterEvoLen)=1
	If EvoTpA(SpeciesCode(1,CounterEvoLen))>EvoLen Then SpeciesCode(9,CounterEvoLen)=1 Else SpeciesCode(9,CounterEvoLen)=0
	CounterEvoLen=CounterEvoLen+1

Return

'-------> 1.05 Start
'*** FirstPartSoupGen2 ***********************************************************************************
FirstPartSoupGen2:
CounterC=0
do
	NumLen=1+INT(RND*5)'number of opcodes
Loop Until EvoLen>=CounterEvoLen+NumLen '1.01

'generate the linear instructions
While NumLen>CounterC
	CounterF=1+Int(Rnd*(ProbSpl+ProbMov+ProbAdd+ProbSne+ProbSeq))
	If CounterF<=ProbSpl Then SpeciesCode(1,CounterEvoLen)=1
	If CounterF>ProbSpl And CounterF <=ProbSpl+(ProbMov/2) Then SpeciesCode(1,CounterEvoLen)=2
	If CounterF>ProbSpl+(ProbMov/2) And CounterF <=ProbSpl+ProbMov Then SpeciesCode(1,CounterEvoLen)=11
	If CounterF>ProbSpl+ProbMov And CounterF <=ProbSpl+ProbMov+ProbAdd Then SpeciesCode(1,CounterEvoLen)=3
	If CounterF>ProbSpl+ProbMov+ProbAdd And CounterF <=ProbSpl+ProbMov+ProbAdd+ProbSne Then SpeciesCode(1,CounterEvoLen)=4		
	If CounterF>ProbSpl+ProbMov+ProbAdd+ProbSne And CounterF <=ProbSpl+ProbMov+ProbAdd+ProbSne+ProbSeq Then SpeciesCode(1,CounterEvoLen)=5
	SpeciesCode(2,CounterEvoLen)=1+INT(RND*8)
	SpeciesCode(3,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
	SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
	SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
	SpeciesCode(6,CounterEvoLen)=1
	If EvoTpA(SpeciesCode(1,CounterEvoLen))>EvoLen Then SpeciesCode(7,CounterEvoLen)=1 Else SpeciesCode(7,CounterEvoLen)=0
	SpeciesCode(8,CounterEvoLen)=1
	If EvoTpA(SpeciesCode(1,CounterEvoLen))>EvoLen Then SpeciesCode(9,CounterEvoLen)=1 Else SpeciesCode(9,CounterEvoLen)=0
	CounterEvoLen=CounterEvoLen+1
	CounterC=CounterC+1
Wend

'generate the loop instruction
	CounterF=1+Int(Rnd*(ProbDjn+ProbJmn+ProbJmz+ProbJmp))
	If CounterF<=(ProbDjn/2) Then SpeciesCode(1,CounterEvoLen)=6
	If CounterF>(ProbDjn/2) And CounterF<=ProbDjn Then SpeciesCode(1,CounterEvoLen)=7
	If CounterF>ProbDjn And CounterF <=ProbDjn+ProbJmn Then SpeciesCode(1,CounterEvoLen)=8
	If CounterF>ProbDjn+ProbJmn And CounterF <=ProbDjn+ProbJmn+ProbJmz Then SpeciesCode(1,CounterEvoLen)=12
	If CounterF>ProbDjn+ProbJmn+ProbJmz And CounterF <=ProbDjn+ProbJmn+ProbJmz+ProbJmp Then SpeciesCode(1,CounterEvoLen)=9
   SpeciesCode(2,CounterEvoLen)=1+INT(RND*8)
	SpeciesCode(3,CounterEvoLen)=-INT(RND*5)
	SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
	SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
	SpeciesCode(6,CounterEvoLen)=1
	If EvoTpA(SpeciesCode(1,CounterEvoLen))>EvoLen Then SpeciesCode(7,CounterEvoLen)=1 Else SpeciesCode(7,CounterEvoLen)=0
	SpeciesCode(8,CounterEvoLen)=1
	If EvoTpA(SpeciesCode(1,CounterEvoLen))>EvoLen Then SpeciesCode(9,CounterEvoLen)=1 Else SpeciesCode(9,CounterEvoLen)=0
	CounterEvoLen=CounterEvoLen+1

Return

'<------- 1.05 End

'*** SecondPartSoupGen ***********************************************************************************
SecondPartSoupGen:
CounterC=0
do
	NumLen=1+INT(RND*4)'number of opcodes
Loop Until EvoLen>=CounterEvoLen+NumLen-1 '1.01
'generate the linear instructions
While NumLen>CounterC
	CounterF=1+Int(Rnd*(ProbSpl+ProbMov+ProbAdd+ProbSne+ProbSeq))
	If CounterF<=ProbSpl Then SpeciesCode(1,CounterEvoLen)=1
	If CounterF>ProbSpl And CounterF <=ProbSpl+(ProbMov/2) Then SpeciesCode(1,CounterEvoLen)=2
	If CounterF>ProbSpl+(ProbMov/2) And CounterF <=ProbSpl+ProbMov Then SpeciesCode(1,CounterEvoLen)=11
	If CounterF>ProbSpl+ProbMov And CounterF <=ProbSpl+ProbMov+ProbAdd Then SpeciesCode(1,CounterEvoLen)=3
	If CounterF>ProbSpl+ProbMov+ProbAdd And CounterF <=ProbSpl+ProbMov+ProbAdd+ProbSne Then SpeciesCode(1,CounterEvoLen)=4		
	If CounterF>ProbSpl+ProbMov+ProbAdd+ProbSne And CounterF <=ProbSpl+ProbMov+ProbAdd+ProbSne+ProbSeq Then SpeciesCode(1,CounterEvoLen)=5
	SpeciesCode(2,CounterEvoLen)=1+INT(RND*8)
	SpeciesCode(3,CounterEvoLen)=INT(RND*((2*EvoTpA(SpeciesCode(1,CounterEvoLen))+1)))-EvoTpA(SpeciesCode(1,CounterEvoLen))
	SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
	SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpA(SpeciesCode(1,CounterEvoLen))+1)))-EvoTpA(SpeciesCode(1,CounterEvoLen))
	SpeciesCode(6,CounterEvoLen)=1
	If EvoTpA(SpeciesCode(1,CounterEvoLen))>EvoLen Then SpeciesCode(7,CounterEvoLen)=1 Else SpeciesCode(7,CounterEvoLen)=0
	SpeciesCode(8,CounterEvoLen)=1
	If EvoTpA(SpeciesCode(1,CounterEvoLen))>EvoLen Then SpeciesCode(9,CounterEvoLen)=1 Else SpeciesCode(9,CounterEvoLen)=0
	
	If SpeciesCode(1,CounterEvoLen)=2 And SpeciesCode(2,CounterEvoLen)=3 And Int(Rnd*3)=1 Then SpeciesCode(3,CounterEvoLen)=CounterImp
	
	CounterEvoLen=CounterEvoLen+1
	CounterC=CounterC+1
	
Wend
return

'-------> 1.05 Start
'*** SecondPartSoupGen2 ***********************************************************************************
SecondPartSoupGen2:
CounterC=0
do
	NumLen=1+INT(RND*4)'number of opcodes
Loop Until EvoLen>=CounterEvoLen+NumLen-1 '1.01
'generate the linear instructions
While NumLen>CounterC
	CounterF=1+Int(Rnd*(ProbSpl+ProbMov+ProbAdd+ProbSne+ProbSeq))
	If CounterF<=ProbSpl Then SpeciesCode(1,CounterEvoLen)=1
	If CounterF>ProbSpl And CounterF <=ProbSpl+(ProbMov/2) Then SpeciesCode(1,CounterEvoLen)=2
	If CounterF>ProbSpl+(ProbMov/2) And CounterF <=ProbSpl+ProbMov Then SpeciesCode(1,CounterEvoLen)=11
	If CounterF>ProbSpl+ProbMov And CounterF <=ProbSpl+ProbMov+ProbAdd Then SpeciesCode(1,CounterEvoLen)=3
	If CounterF>ProbSpl+ProbMov+ProbAdd And CounterF <=ProbSpl+ProbMov+ProbAdd+ProbSne Then SpeciesCode(1,CounterEvoLen)=4		
	If CounterF>ProbSpl+ProbMov+ProbAdd+ProbSne And CounterF <=ProbSpl+ProbMov+ProbAdd+ProbSne+ProbSeq Then SpeciesCode(1,CounterEvoLen)=5
	SpeciesCode(2,CounterEvoLen)=1+INT(RND*8)
	SpeciesCode(3,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
	SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
	SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
	SpeciesCode(6,CounterEvoLen)=1
	If EvoTpA(SpeciesCode(1,CounterEvoLen))>EvoLen Then SpeciesCode(7,CounterEvoLen)=1 Else SpeciesCode(7,CounterEvoLen)=0
	SpeciesCode(8,CounterEvoLen)=1
	If EvoTpA(SpeciesCode(1,CounterEvoLen))>EvoLen Then SpeciesCode(9,CounterEvoLen)=1 Else SpeciesCode(9,CounterEvoLen)=0
	
	If SpeciesCode(1,CounterEvoLen)=2 And SpeciesCode(2,CounterEvoLen)=3 And Int(Rnd*3)=1 Then SpeciesCode(3,CounterEvoLen)=CounterImp
	
	CounterEvoLen=CounterEvoLen+1
	CounterC=CounterC+1
	
Wend
return
'<------- 1.05 End

'*** SecondPartPaperGen ***********************************************************************************
SecondPartPaperGen:

	CounterC=1+INT(RND*5)
	If CounterC=1 Then 
		'djn.b   $-x,_xxx
		SpeciesCode(1,CounterEvoLen)=7
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=-INT(RND*5)
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
	EndIf
	If CounterC=2 Then 
		'mov.i   {-x, <1
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=4+Int(Rnd*3)
		SpeciesCode(3,CounterEvoLen)=-INT(RND*5)
		SpeciesCode(4,CounterEvoLen)=4
		SpeciesCode(5,CounterEvoLen)=1
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'djn.f   @0,_xxx
		SpeciesCode(1,CounterEvoLen)=6
		SpeciesCode(2,CounterEvoLen)=2
		SpeciesCode(3,CounterEvoLen)=0
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
	EndIf
		If CounterC=3 Then 
		'mov.i   {-x, <1
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=4+Int(Rnd*3)
		SpeciesCode(3,CounterEvoLen)=-INT(RND*8)
		SpeciesCode(4,CounterEvoLen)=4
		SpeciesCode(5,CounterEvoLen)=1
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'jmz.a   @0,$xxx
		SpeciesCode(1,CounterEvoLen)=14
		SpeciesCode(2,CounterEvoLen)=2
		SpeciesCode(3,CounterEvoLen)=0
		SpeciesCode(4,CounterEvoLen)=1
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
	EndIf
	If CounterC>3 Then 
		'mov.i   {-x, <1
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=4+Int(Rnd*3)
		SpeciesCode(3,CounterEvoLen)=-INT(RND*8)
		SpeciesCode(4,CounterEvoLen)=4
		SpeciesCode(5,CounterEvoLen)=1
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'jmp.b   @0,_xxx
		SpeciesCode(1,CounterEvoLen)=9
		SpeciesCode(2,CounterEvoLen)=2
		SpeciesCode(3,CounterEvoLen)=0
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
	EndIf
return

'*** second part paper auxiliary generation ************************************************
SecondPartPaperAuxGen:

	CounterC=1+INT(RND*4)
	If CounterC=1 Then 
		'spl   #xxx, 	   _xxx
		SpeciesCode(1,CounterEvoLen)=1
		SpeciesCode(2,CounterEvoLen)=3
		SpeciesCode(3,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
		'spl   2+(impstep*2), _xxx
		SpeciesCode(1,CounterEvoLen)=1
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=2+(CounterImp*2)
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
		'spl   1+impstep,     _xxx
		SpeciesCode(1,CounterEvoLen)=1
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=1+CounterImp
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
			CounterD=Int(Rnd*16)
			If CounterD<8 Then
				'mov.i   #xxx, Counterimp
				SpeciesCode(1,CounterEvoLen)=2
				SpeciesCode(2,CounterEvoLen)=3
				SpeciesCode(3,CounterEvoLen)=Int(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
				SpeciesCode(4,CounterEvoLen)=1
				SpeciesCode(5,CounterEvoLen)=CounterImp
				SpeciesCode(6,CounterEvoLen)=0
				SpeciesCode(7,CounterEvoLen)=0
				SpeciesCode(8,CounterEvoLen)=0
				SpeciesCode(9,CounterEvoLen)=0
				CounterEvoLen=CounterEvoLen+1
			EndIf
			If CounterD>=8 Then
				'mov.i   #Counterimp,*0
				SpeciesCode(1,CounterEvoLen)=2
				SpeciesCode(2,CounterEvoLen)=3
				SpeciesCode(3,CounterEvoLen)=CounterImp
				SpeciesCode(4,CounterEvoLen)=8
				SpeciesCode(5,CounterEvoLen)=0
				SpeciesCode(6,CounterEvoLen)=0
				SpeciesCode(7,CounterEvoLen)=0
				SpeciesCode(8,CounterEvoLen)=0
				SpeciesCode(9,CounterEvoLen)=0
				CounterEvoLen=CounterEvoLen+1
			EndIf
	EndIf	
	If CounterC=2 Then 
		'spl	#xxx, _xxx
		SpeciesCode(1,CounterEvoLen)=1
		SpeciesCode(2,CounterEvoLen)=3
		SpeciesCode(3,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
		'add.a	#impstep, $1
		SpeciesCode(1,CounterEvoLen)=16
		SpeciesCode(2,CounterEvoLen)=3
		SpeciesCode(3,CounterEvoLen)=CounterImp
		SpeciesCode(4,CounterEvoLen)=1
		SpeciesCode(5,CounterEvoLen)=1
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'jmp	1-impstep+1, _xxx
		SpeciesCode(1,CounterEvoLen)=9
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=1-CounterImp+INT(RND*4)-3
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
			CounterD=Int(Rnd*16)
			If CounterD<8 Then
				'mov.i   #xxx, Counterimp
				SpeciesCode(1,CounterEvoLen)=2
				SpeciesCode(2,CounterEvoLen)=3
				SpeciesCode(3,CounterEvoLen)=Int(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
				SpeciesCode(4,CounterEvoLen)=1
				SpeciesCode(5,CounterEvoLen)=CounterImp
				SpeciesCode(6,CounterEvoLen)=0
				SpeciesCode(7,CounterEvoLen)=0
				SpeciesCode(8,CounterEvoLen)=0
				SpeciesCode(9,CounterEvoLen)=0
				CounterEvoLen=CounterEvoLen+1
			EndIf
			If CounterD>=8 Then
				'mov.i   #Counterimp,*0
				SpeciesCode(1,CounterEvoLen)=2
				SpeciesCode(2,CounterEvoLen)=3
				SpeciesCode(3,CounterEvoLen)=CounterImp
				SpeciesCode(4,CounterEvoLen)=8
				SpeciesCode(5,CounterEvoLen)=0
				SpeciesCode(6,CounterEvoLen)=0
				SpeciesCode(7,CounterEvoLen)=0
				SpeciesCode(8,CounterEvoLen)=0
				SpeciesCode(9,CounterEvoLen)=0
				CounterEvoLen=CounterEvoLen+1
			EndIf
	EndIf	
	If CounterC>2 Then 
		'spl   #xxx, 	   _xxx
		SpeciesCode(1,CounterEvoLen)=1
		SpeciesCode(2,CounterEvoLen)=3
		SpeciesCode(3,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=1
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
		'MOV >xxx,$xxx
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=4+INT(RND*4)
		SpeciesCode(3,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(4,CounterEvoLen)=1
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=1
		SpeciesCode(7,CounterEvoLen)=1
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
		'ADD $-2,$-1
		SpeciesCode(1,CounterEvoLen)=44
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=-2
		SpeciesCode(4,CounterEvoLen)=1
		SpeciesCode(5,CounterEvoLen)=-1
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'DJN.f  $-2,_xxx
		SpeciesCode(1,CounterEvoLen)=6
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=-2
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
	EndIf	
return


'*** generate the dat block *************************************
LastPartDatGen:
CounterC=0
do
NumLen=1+INT(RND*3)'number of opcodes
Loop Until EvoLen>=CounterEvoLen+NumLen-1 '1.01
While NumLen>CounterC		
		SpeciesCode(1,CounterEvoLen)=10
		SpeciesCode(2,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(3,CounterEvoLen)=INT(RND*((2*EvoTpA(10)+1)))-EvoTpA(10)
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpA(10)+1)))-EvoTpA(10)
		SpeciesCode(6,CounterEvoLen)=1
		SpeciesCode(7,CounterEvoLen)=1
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
		CounterC=CounterC+1
Wend
Return

'-------->1.05cs start
'*** Generate the stone main block ************
StonePartFirstGen:

	CounterC=1+INT(RND*5)
	
	' tornado part--------------
	If CounterC=1 Then 
		CounterF=INT(RND*(EvoLen)+1)
		'mov     $x1,  *2
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=CounterF
		SpeciesCode(4,CounterEvoLen)=8
		SpeciesCode(5,CounterEvoLen)=2
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'mov     $x1,  @1
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=CounterF-1
		SpeciesCode(4,CounterEvoLen)=2
		SpeciesCode(5,CounterEvoLen)=1
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'mov     $xxx, @xxx
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(4,CounterEvoLen)=2
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=1
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
		'add.f     $x,   -1
		SpeciesCode(1,CounterEvoLen)=44
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=INT(RND*5+2)
		SpeciesCode(4,CounterEvoLen)=1
		SpeciesCode(5,CounterEvoLen)=-1
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		CounterE=INT(RND*4)
		If CounterE<2 Then
		'djn.b   $-4,  #xxx
		SpeciesCode(1,CounterEvoLen)=7
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=-4
		SpeciesCode(4,CounterEvoLen)=3
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1		
		EndIf
		If CounterE>=2 Then
		'DJN.f  $-4,_xxx
		SpeciesCode(1,CounterEvoLen)=6
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=-4
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
		EndIf
	EndIf
	' incendiary part--------------
	If CounterC=2 Then 
		'spl	#1,	$xxx
		SpeciesCode(1,CounterEvoLen)=1
		SpeciesCode(2,CounterEvoLen)=3
		SpeciesCode(3,CounterEvoLen)=1
		SpeciesCode(4,CounterEvoLen)=1
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
		'add.ab	#xxx,	    $1
		SpeciesCode(1,CounterEvoLen)=13
		SpeciesCode(2,CounterEvoLen)=3
		SpeciesCode(3,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(4,CounterEvoLen)=1
		SpeciesCode(5,CounterEvoLen)=1
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=1
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'mov	$x,	>xxx
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=INT(RND*10)
		SpeciesCode(4,CounterEvoLen)=5
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
		'mov	$-3,	@  -1
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=-3
		SpeciesCode(4,CounterEvoLen)=2
		SpeciesCode(5,CounterEvoLen)=-1
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		CounterE=INT(RND*4)
		If CounterE<2 Then
		'djn.b   $-3,  #xxx
		SpeciesCode(1,CounterEvoLen)=7
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=-3
		SpeciesCode(4,CounterEvoLen)=3
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1		
		EndIf
		If CounterE>=2 Then
		'DJN.f  $-3,_xxx
		SpeciesCode(1,CounterEvoLen)=6
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=-3
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
		EndIf
	EndIf
	' bluefunk djn.f part-----------------
	If CounterC=3 Then 
		'spl   #xxx, 	   _xxx
		SpeciesCode(1,CounterEvoLen)=1
		SpeciesCode(2,CounterEvoLen)=3
		SpeciesCode(3,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=1
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
		'MOV >xxx,$xxx
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=4+INT(RND*4)
		SpeciesCode(3,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(4,CounterEvoLen)=1
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=1
		SpeciesCode(7,CounterEvoLen)=1
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
		'ADD $-2,$-1
		SpeciesCode(1,CounterEvoLen)=44
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=-2
		SpeciesCode(4,CounterEvoLen)=1
		SpeciesCode(5,CounterEvoLen)=-1
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'DJN.f  $-2,_xxx
		SpeciesCode(1,CounterEvoLen)=6
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=-2
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
	EndIf	
		' bluefunk djn.b part-----------------
	If CounterC=4 Then 
		'spl   #xxx, 	   _xxx
		SpeciesCode(1,CounterEvoLen)=1
		SpeciesCode(2,CounterEvoLen)=3
		SpeciesCode(3,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=1
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
		'MOV >xxx,$xxx
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=4+INT(RND*4)
		SpeciesCode(3,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(4,CounterEvoLen)=1
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=1
		SpeciesCode(7,CounterEvoLen)=1
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
		'ADD $-2,$-1
		SpeciesCode(1,CounterEvoLen)=44
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=-2
		SpeciesCode(4,CounterEvoLen)=1
		SpeciesCode(5,CounterEvoLen)=-1
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		CounterE=INT(RND*4)
		If CounterE<2 Then
		'djn.b   $-2,  #xxx
		SpeciesCode(1,CounterEvoLen)=7
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=-2
		SpeciesCode(4,CounterEvoLen)=3
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1		
		EndIf
		If CounterE>=2 Then
		'DJN.f  $-2,_xxx
		SpeciesCode(1,CounterEvoLen)=6
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=-2
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
		EndIf
	EndIf
		' spl -1 stone part-----------------
	If CounterC=5 Then 
		'mov.i   -x,>1
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=INT(RND*((2*EvoTpB(2)+1)))-EvoTpB(2)
		SpeciesCode(4,CounterEvoLen)=4+INT(RND*4)
		SpeciesCode(5,CounterEvoLen)=1
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=1
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'spl   $-1, 	_xxx
		SpeciesCode(1,CounterEvoLen)=1
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=-1
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
		'ADD.ab #xxx,$-1
		SpeciesCode(1,CounterEvoLen)=13
		SpeciesCode(2,CounterEvoLen)=3
		SpeciesCode(3,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(4,CounterEvoLen)=1
		SpeciesCode(5,CounterEvoLen)=-1
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=1
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		CounterE=INT(RND*4)
		If CounterE<2 Then
		'djn.b   $-2,  #xxx
		SpeciesCode(1,CounterEvoLen)=7
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=-2
		SpeciesCode(4,CounterEvoLen)=3
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1		
		EndIf
		If CounterE>=2 Then
		'DJN.f  $-2,_xxx
		SpeciesCode(1,CounterEvoLen)=6
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=-2
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
		EndIf
	EndIf
return


'*** generate the Stone End block *************************************
StonePartEndGen:

	CounterC=1+INT(RND*12)
	If CounterC>0 Then 
		If INT(RND*4)>2 Then
		'spl.b   #xxx,           _xxx
		SpeciesCode(1,CounterEvoLen)=1
		SpeciesCode(2,CounterEvoLen)=3
		SpeciesCode(3,CounterEvoLen)=INT(RND*((2*EvoTpA(10)+1)))-EvoTpA(10)
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpA(10)+1)))-EvoTpA(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=1
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
		EndIf
		'mov.i   $2,             >-x1
		CounterF=-Int(Rnd*8)
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=2
		SpeciesCode(4,CounterEvoLen)=5
		SpeciesCode(5,CounterEvoLen)=CounterF
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'djn.f   $-1,            >-x1+1
		SpeciesCode(1,CounterEvoLen)=6
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=-1
		SpeciesCode(4,CounterEvoLen)=5
		SpeciesCode(5,CounterEvoLen)=CounterF-1
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'dat.f   <xxx,           $x1+3
		SpeciesCode(1,CounterEvoLen)=10
		SpeciesCode(2,CounterEvoLen)=4
		SpeciesCode(3,CounterEvoLen)=INT(RND*((2*EvoTpA(10)+1)))-EvoTpA(10)
		SpeciesCode(4,CounterEvoLen)=1
		SpeciesCode(5,CounterEvoLen)=-CounterF+3
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=1
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
	EndIf
	If CounterC>20 And CounterC<=25 then '1.05
		If (Rnd*4)>2 Then
		'spl.b   #xxx,           _xxx
		SpeciesCode(1,CounterEvoLen)=1
		SpeciesCode(2,CounterEvoLen)=3
		SpeciesCode(3,CounterEvoLen)=INT(RND*((2*EvoTpA(10)+1)))-EvoTpA(10)
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpA(10)+1)))-EvoTpA(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=1
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
		EndIf
		'mov.i   @2,             >-x1
		CounterF=-Int(Rnd*8)
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=2
		SpeciesCode(3,CounterEvoLen)=2
		SpeciesCode(4,CounterEvoLen)=5
		SpeciesCode(5,CounterEvoLen)=CounterF
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'mov.i   @1,             >-x1
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=2
		SpeciesCode(3,CounterEvoLen)=1
		SpeciesCode(4,CounterEvoLen)=5
		SpeciesCode(5,CounterEvoLen)=CounterF-1
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'djn.f   $-2,            {2
		SpeciesCode(1,CounterEvoLen)=6
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=-2
		SpeciesCode(4,CounterEvoLen)=6
		SpeciesCode(5,CounterEvoLen)=2
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'dat.f   #x,           $x1+3
		SpeciesCode(1,CounterEvoLen)=10
		SpeciesCode(2,CounterEvoLen)=3
		SpeciesCode(3,CounterEvoLen)=-5-INT(RND*10)
		SpeciesCode(4,CounterEvoLen)=1
		SpeciesCode(5,CounterEvoLen)=1-CounterF+3
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=1
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'spl.b   #x,           $x1+3
		SpeciesCode(1,CounterEvoLen)=1
		If (Rnd*3)>2 Then SpeciesCode(1,CounterEvoLen)=9'1.06cs
		SpeciesCode(2,CounterEvoLen)=3
		SpeciesCode(3,CounterEvoLen)=-5-INT(RND*10)
		SpeciesCode(4,CounterEvoLen)=1
		SpeciesCode(5,CounterEvoLen)=1-CounterF+4
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=1
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
	EndIf
Return
'-------->1.05cs End

'*** generate the pre block *************************************
ScanPartPreGen:
CounterC=0
do
NumLen=INT(RND*4)'number of opcodes
Loop Until EvoLen>=CounterEvoLen+NumLen
While NumLen>CounterC		
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(3,CounterEvoLen)=INT(RND*((2*EvoTpA(2)+1)))-EvoTpA(2)
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpA(10)+1)))-EvoTpA(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
		CounterC=CounterC+1
Wend
Return

'*** generate the scan block *************************************
ScanPartScanGen:

	CounterC=1+INT(RND*4)'1.05
	
	' 0.5c scanner part--------------
	If CounterC=1 Then 
		'add.ab   #xxx, $1
		SpeciesCode(1,CounterEvoLen)=13
		SpeciesCode(2,CounterEvoLen)=3
		SpeciesCode(3,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(4,CounterEvoLen)=1
		SpeciesCode(5,CounterEvoLen)=1
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=1
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'JMZ.F   $-1,  _xxx
		SpeciesCode(1,CounterEvoLen)=12
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=-1-Int(Rnd*4)
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpA(10)+1)))-EvoTpA(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
	EndIf
	
	' 0.66c scanner part-------------
	If CounterC=2 Then 
		'ADD.f   $x,             $1
		SpeciesCode(1,CounterEvoLen)=3
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=3+INT(RND*10)
		SpeciesCode(4,CounterEvoLen)=1
		SpeciesCode(5,CounterEvoLen)=1
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'SNE.i   $xxx,           $xxx
		SpeciesCode(1,CounterEvoLen)=4
		SpeciesCode(2,CounterEvoLen)=4+INT(RND*4)
		SpeciesCode(3,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(4,CounterEvoLen)=4+INT(RND*4)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=1
		SpeciesCode(7,CounterEvoLen)=1
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
		'JMP.b   $-2,            _xxx (or DNJ.f or DJN.a)
		CounterF=Int(Rnd*5)
		If CounterF<=2 Then SpeciesCode(1,CounterEvoLen)=9
		If CounterF>2 And CounterF<=4 Then SpeciesCode(1,CounterEvoLen)=6
		If CounterF>4 Then SpeciesCode(1,CounterEvoLen)=7
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=-2-Int(Rnd*4)
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
	EndIf
	
	' blur scanner part--------------
	If CounterC=3 Then '1.05
		'mov.i $x+5,>x+5
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=5
		SpeciesCode(4,CounterEvoLen)=5
		SpeciesCode(5,CounterEvoLen)=5
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'add.f $x,$1
		SpeciesCode(1,CounterEvoLen)=3
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=4+INT(RND*5)
		SpeciesCode(4,CounterEvoLen)=1
		SpeciesCode(5,CounterEvoLen)=1
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'sne.i _xxx,_xxx
		SpeciesCode(1,CounterEvoLen)=4
		SpeciesCode(2,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(3,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=1
		SpeciesCode(7,CounterEvoLen)=1
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
		'mov.b $-1,@-3
		SpeciesCode(1,CounterEvoLen)=15
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=-1
		SpeciesCode(4,CounterEvoLen)=2
		SpeciesCode(5,CounterEvoLen)=-3
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'djn $-4,#xxx
		SpeciesCode(1,CounterEvoLen)=7
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=-4
		SpeciesCode(4,CounterEvoLen)=3
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
	EndIf
	'------>1.05 start
	' scanning stone part-------------
	If CounterC=4 Then 
		'sub.x $x, 1
		SpeciesCode(1,CounterEvoLen)=45
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=3+INT(RND*10)
		SpeciesCode(4,CounterEvoLen)=1
		SpeciesCode(5,CounterEvoLen)=1
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'mov.i }xxx, $xxx
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=7
		SpeciesCode(3,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(4,CounterEvoLen)=1
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=1
		SpeciesCode(7,CounterEvoLen)=1
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
		'jmz.f $-2, {-1
		SpeciesCode(1,CounterEvoLen)=12
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=-2
		SpeciesCode(4,CounterEvoLen)=6
		SpeciesCode(5,CounterEvoLen)=-1
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
		If (Rnd*5)>2 Then
		'mov.x $-2, $-2
		SpeciesCode(1,CounterEvoLen)=24
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=-2
		SpeciesCode(4,CounterEvoLen)=1
		SpeciesCode(5,CounterEvoLen)=-2
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		EndIf
	EndIf
	'<---------1.05 end
Return

'*** generate the attack block *************************************
ScanPartAttackGen:

	CounterC=1+INT(RND*8)
	If CounterC<=4 Then 
		'mov.i   $x,            @-x
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=2
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=-1-INT(RND*5)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'djn.b    $-x,         #xxx
		SpeciesCode(1,CounterEvoLen)=7
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=-INT(RND*10)
		SpeciesCode(4,CounterEvoLen)=3
		SpeciesCode(5,CounterEvoLen)=INT(RND*40)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
	EndIf
	If CounterC>4 Then 
		'mov.i   $3,     _-2       
		CounterF=Int(Rnd*2)
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=3
		SpeciesCode(4,CounterEvoLen)=4+Int(Rnd*2)
		SpeciesCode(5,CounterEvoLen)=-2-CounterF
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'mov.i   $x,            @-x
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=2
		SpeciesCode(4,CounterEvoLen)=6+Int(Rnd*2)
		SpeciesCode(5,CounterEvoLen)=-3-CounterF
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'djn.b    $-x,         #xxx
		SpeciesCode(1,CounterEvoLen)=7
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=-3-Int(Rnd*2)
		SpeciesCode(4,CounterEvoLen)=3
		SpeciesCode(5,CounterEvoLen)=INT(RND*100)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
	EndIf
Return

'*** generate the End block *************************************
ScanPartEndGen:

	CounterC=1+INT(RND*12)
	If CounterC=0 Then '1.05
		If (Rnd*12)>3 Then
		'spl.b   #xxx,           _xxx
		SpeciesCode(1,CounterEvoLen)=1
		SpeciesCode(2,CounterEvoLen)=3
		SpeciesCode(3,CounterEvoLen)=INT(RND*((2*EvoTpA(10)+1)))-EvoTpA(10)
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpA(10)+1)))-EvoTpA(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=1
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
		EndIf
		'mov.i   $2,             >-x1
		CounterF=-Int(Rnd*8)
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=2
		SpeciesCode(4,CounterEvoLen)=5
		SpeciesCode(5,CounterEvoLen)=CounterF
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'djn.f   $-1,            >-x1+1
		SpeciesCode(1,CounterEvoLen)=6
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=-1
		SpeciesCode(4,CounterEvoLen)=5
		SpeciesCode(5,CounterEvoLen)=CounterF-1
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'dat.f   <xxx,           $x1+3
		SpeciesCode(1,CounterEvoLen)=10
		SpeciesCode(2,CounterEvoLen)=4
		SpeciesCode(3,CounterEvoLen)=INT(RND*((2*EvoTpA(10)+1)))-EvoTpA(10)
		SpeciesCode(4,CounterEvoLen)=1
		SpeciesCode(5,CounterEvoLen)=-CounterF+3
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=1
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
	EndIf
	
	If CounterC>0 And CounterC<=8 then '1.05
		If (Rnd*12)>3 Then
		'spl.b   #xxx,           _xxx
		SpeciesCode(1,CounterEvoLen)=1
		SpeciesCode(2,CounterEvoLen)=3
		SpeciesCode(3,CounterEvoLen)=INT(RND*((2*EvoTpA(10)+1)))-EvoTpA(10)
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpA(10)+1)))-EvoTpA(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=1
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
		EndIf
		'mov.i   @2,             >-x1
		CounterF=-Int(Rnd*8)
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=2
		SpeciesCode(3,CounterEvoLen)=2
		SpeciesCode(4,CounterEvoLen)=5
		SpeciesCode(5,CounterEvoLen)=CounterF
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'mov.i   @1,             >-x1
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=2
		SpeciesCode(3,CounterEvoLen)=1
		SpeciesCode(4,CounterEvoLen)=5
		SpeciesCode(5,CounterEvoLen)=CounterF-1
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'djn.f   $-2,            {2
		SpeciesCode(1,CounterEvoLen)=6
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=-2
		SpeciesCode(4,CounterEvoLen)=6
		SpeciesCode(5,CounterEvoLen)=2
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'dat.f   #x,           $x1+3
		SpeciesCode(1,CounterEvoLen)=10
		SpeciesCode(2,CounterEvoLen)=3
		SpeciesCode(3,CounterEvoLen)=-5-INT(RND*10)
		SpeciesCode(4,CounterEvoLen)=1
		SpeciesCode(5,CounterEvoLen)=1-CounterF+3
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=1
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'spl.b   #x,           $x1+3
		SpeciesCode(1,CounterEvoLen)=1
		If (Rnd*3)>2 Then SpeciesCode(1,CounterEvoLen)=9'1.06cs
		SpeciesCode(2,CounterEvoLen)=3
		SpeciesCode(3,CounterEvoLen)=-5-INT(RND*10)
		SpeciesCode(4,CounterEvoLen)=1
		SpeciesCode(5,CounterEvoLen)=1-CounterF+4
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=1
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
	EndIf
	
	If CounterC>8 Then 
		'add.a   #Coresize/x+2, 3
		SpeciesCode(1,CounterEvoLen)=16
		SpeciesCode(2,CounterEvoLen)=3
		SpeciesCode(3,CounterEvoLen)=(CoreSize/INT(RND*25))+2
		SpeciesCode(4,CounterEvoLen)=1
		SpeciesCode(5,CounterEvoLen)=3
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'mov	@-1,	{2
		CounterF=-Int(Rnd*8)
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=2
		SpeciesCode(3,CounterEvoLen)=-1
		SpeciesCode(4,CounterEvoLen)=6
		SpeciesCode(5,CounterEvoLen)=2
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'jmp     -2, $xxx
		SpeciesCode(1,CounterEvoLen)=9
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=-2
		SpeciesCode(4,CounterEvoLen)=1
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpA(10)+1)))-EvoTpA(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
		'spl	#1,	#4
		SpeciesCode(1,CounterEvoLen)=1
		SpeciesCode(2,CounterEvoLen)=3
		SpeciesCode(3,CounterEvoLen)=INT(RND*10)
		SpeciesCode(4,CounterEvoLen)=3
		SpeciesCode(5,CounterEvoLen)=INT(RND*10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
	EndIf
	
Return

'*** generate the spl/dat block *************************************
LastPartSplDatGen:
CounterC=0
do
NumLen=INT(RND*4)'number of opcodes
Loop Until EvoLen>=CounterEvoLen+NumLen
While NumLen>CounterC
		CounterF=Int(Rnd*10)
		If CounterF>5 Then SpeciesCode(1,CounterEvoLen)=10 Else SpeciesCode(1,CounterEvoLen)=1
		SpeciesCode(2,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(3,CounterEvoLen)=INT(RND*((2*EvoTpA(10)+1)))-EvoTpA(10)
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpA(10)+1)))-EvoTpA(10)
		SpeciesCode(6,CounterEvoLen)=1
		SpeciesCode(7,CounterEvoLen)=1
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
		CounterC=CounterC+1
Wend
Return

'<------------1.05 start
'*** ImpGen ***********************************************************************************
ImpGen:

CounterImp=(CoreSize+1)/(3+Int(Rnd*2)*2)

	CounterC=1+INT(RND*5)
	CounterD=Int(Rnd*16)
	If CounterC>0 Then 
		'spl #0, >1
		SpeciesCode(1,CounterEvoLen)=1
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=0
		SpeciesCode(4,CounterEvoLen)=5
		SpeciesCode(5,CounterEvoLen)=1
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'mov.i   $3, $3
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=3
		SpeciesCode(4,CounterEvoLen)=1
		SpeciesCode(5,CounterEvoLen)=3
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'add.a #CounterImp+1, $1
		SpeciesCode(1,CounterEvoLen)=16
		SpeciesCode(2,CounterEvoLen)=3
		SpeciesCode(3,CounterEvoLen)=CounterImp+1
		SpeciesCode(4,CounterEvoLen)=1
		SpeciesCode(5,CounterEvoLen)=1
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'jmp.b  $1-CounterImp-1, _xxx
		SpeciesCode(1,CounterEvoLen)=9
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=1-CounterImp-1
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=1
		SpeciesCode(8,CounterEvoLen)=1
		SpeciesCode(9,CounterEvoLen)=1
		CounterEvoLen=CounterEvoLen+1
		If CounterD<8 Then
		'mov.i   #xxx, Counterimp
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=3
		SpeciesCode(3,CounterEvoLen)=Int(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(4,CounterEvoLen)=1
		SpeciesCode(5,CounterEvoLen)=CounterImp
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		EndIf
		If CounterD>=8 Then
		'mov.i   #Counterimp,*0
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=3
		SpeciesCode(3,CounterEvoLen)=CounterImp
		SpeciesCode(4,CounterEvoLen)=8
		SpeciesCode(5,CounterEvoLen)=0
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		EndIf
	EndIf

Return

'*** PaperBootGen ***********************************************************************************
PaperBootGen:

	CounterC=Int(Rnd*4)+1
	If CounterC=1 Then 
		'spl    $xxx,_xxx
		SpeciesCode(1,CounterEvoLen)=1
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=Int(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=Int(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'mov.i    }3,    }-1
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=7
		SpeciesCode(3,CounterEvoLen)=3
		SpeciesCode(4,CounterEvoLen)=7
		SpeciesCode(5,CounterEvoLen)=-1
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'mov.i   {2, {1
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=6
		SpeciesCode(3,CounterEvoLen)=2
		SpeciesCode(4,CounterEvoLen)=6
		SpeciesCode(5,CounterEvoLen)=1
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'jmp    $xxx, _xxx
		SpeciesCode(1,CounterEvoLen)=9
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
	EndIf
If CounterC=2 Then 
		'mov.i    }2,    }1
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=7
		SpeciesCode(3,CounterEvoLen)=2
		SpeciesCode(4,CounterEvoLen)=7
		SpeciesCode(5,CounterEvoLen)=1
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'jmp    $xxx,_xxx
		SpeciesCode(1,CounterEvoLen)=9
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=Int(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=Int(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
EndIf
If CounterC=3 Then 
		'mov.i    >1,    }1
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=5
		SpeciesCode(3,CounterEvoLen)=1
		SpeciesCode(4,CounterEvoLen)=7
		SpeciesCode(5,CounterEvoLen)=1
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'jmp    $xxx,$1
		SpeciesCode(1,CounterEvoLen)=9
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=Int(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(4,CounterEvoLen)=1
		SpeciesCode(5,CounterEvoLen)=1
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
	EndIf
Return

'*** MiscGen ***********************************************************************************
MiscGen:

	CounterC=1+INT(RND*5)
	If CounterC>0 Then 
		'djn.b 0, #x  
		SpeciesCode(1,CounterEvoLen)=7
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=0
		SpeciesCode(4,CounterEvoLen)=3
		SpeciesCode(5,CounterEvoLen)=1+Int(Rnd*15)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
	EndIf

Return


'*** PaperImpGen ***********************************************************************************
PaperImpGen:

	CounterC=Int(Rnd*16)
	If CounterC<8 Then
		'mov.i   #xxx, Counterimp
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=3
		SpeciesCode(3,CounterEvoLen)=Int(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(4,CounterEvoLen)=1
		SpeciesCode(5,CounterEvoLen)=CounterImp
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		EndIf
		If CounterC>=8 Then
		'mov.i   #Counterimp,*0
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=3
		SpeciesCode(3,CounterEvoLen)=CounterImp
		SpeciesCode(4,CounterEvoLen)=8
		SpeciesCode(5,CounterEvoLen)=0
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
	EndIf

Return
'------------>1.05 end

'<-----------1.06cs start
'*** FirstPartLPPaperGen ***********************************************************************************
FirstPartLPPaperGen:

CounterC=Int(RND*EvoTpB(2))

		'mov.i   #x, _x
		SpeciesCode(1,CounterEvoLen)=26
		SpeciesCode(2,CounterEvoLen)=3
		SpeciesCode(3,CounterEvoLen)=CounterC
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=CounterC
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
Return

'*** SecondPartLPPaperGen ***********************************************************************************
SecondPartLPPaperGen:

	CounterC=Int(Rnd*2)+1
	CounterD=Int(Rnd*9)

	If CounterC=1 Then 
		'mov     <-1-x,  {3
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=4
		SpeciesCode(3,CounterEvoLen)=-1-CounterD
		SpeciesCode(4,CounterEvoLen)=6
		SpeciesCode(5,CounterEvoLen)=3
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'jmn     $-1-x,  $-2-x
		SpeciesCode(1,CounterEvoLen)=50
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=-1-CounterD
		SpeciesCode(4,CounterEvoLen)=1
		SpeciesCode(5,CounterEvoLen)=-2-CounterD
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'spl     >-3-x, _xxx
		SpeciesCode(1,CounterEvoLen)=1
		SpeciesCode(2,CounterEvoLen)=5
		SpeciesCode(3,CounterEvoLen)=-3-CounterD
		SpeciesCode(4,CounterEvoLen)=1+INT(RND*8)
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'jmz     $xxx,   *0
		SpeciesCode(1,CounterEvoLen)=51
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(4,CounterEvoLen)=8
		SpeciesCode(5,CounterEvoLen)=0
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
	EndIf
	If CounterC=2 Then 
		'mov     <-1-x,  <3
		SpeciesCode(1,CounterEvoLen)=2
		SpeciesCode(2,CounterEvoLen)=4
		SpeciesCode(3,CounterEvoLen)=-1-CounterD
		SpeciesCode(4,CounterEvoLen)=4
		SpeciesCode(5,CounterEvoLen)=3
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'jmn     $-1-x,  $-2-x
		SpeciesCode(1,CounterEvoLen)=50
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=-1-CounterD
		SpeciesCode(4,CounterEvoLen)=1
		SpeciesCode(5,CounterEvoLen)=-2-CounterD
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'spl     $-3-x, _xxx
		SpeciesCode(1,CounterEvoLen)=1
		SpeciesCode(2,CounterEvoLen)=1
		SpeciesCode(3,CounterEvoLen)=-3-CounterD
		SpeciesCode(4,CounterEvoLen)=1
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
		'jmn.a   @0,     $xxx
		SpeciesCode(1,CounterEvoLen)=22
		SpeciesCode(2,CounterEvoLen)=2
		SpeciesCode(3,CounterEvoLen)=0
		SpeciesCode(4,CounterEvoLen)=1
		SpeciesCode(5,CounterEvoLen)=INT(RND*((2*EvoTpB(10)+1)))-EvoTpB(10)
		SpeciesCode(6,CounterEvoLen)=0
		SpeciesCode(7,CounterEvoLen)=0
		SpeciesCode(8,CounterEvoLen)=0
		SpeciesCode(9,CounterEvoLen)=0
		CounterEvoLen=CounterEvoLen+1
	EndIf

Return

'############################ Mutation Code #############################################


'------------- Mutate from Soup -------------------------------------------------
'this is called from the stock pure code which is modified so
'if a mutation does not occur (soup empty) then runs the stock code
MutateFromSoup:
If SoupIterations > 0 Then
 For SoupIterCount = 1 To SoupIterations
  Gosub MutateWithinSoup  'do parallel evolution within soup
 Next SoupIterCount
End If
SoupEntry = Int(Rnd*SoupSize+1)      'select a random soup warrior
If SoupCode (SoupEntry,1,1) > 0 Then 'if soup warrior exists
 Gosub GetSoupEntry                  'load into speciescode array
 Gosub MutateSpecies                 'change it (avoid dups)
 If CountOfChanges >= MinChanges Then CounterEvoLen = EvoLen + 1  '1.01b/1.02x1
EndIf
Return

'----------------Check and save soup ---------------------------------------------
CheckAndSaveSoup:
If EnableMutation And SaveSoup Then '1.01e1 better logic
 Print "(saving soup)"
 'save soup array to soup directory
 For SoupEntry = 1 To SoupSize
  If SoupCode (SoupEntry,1,1) > 0 Then
   WarFilename = "soup"+PathSym+Str(SoupEntry)+".red"
   Gosub WriteSoupWarrior
  EndIf
 Next SoupEntry
EndIf
Return

'-----------------Reload soup array from soup or species directory ---------------

LoadSoup:
 If SaveSoup = 1 Then TempStoreTxt = "soup" Else TempStoreTxt = "species"
 CounterEvoLen=0 'here using as flag to detect if warriors loaded
 WarFilename = Dir(TempStoreTxt+PathSym+"*.red")
 If WarFilename<>"" Then Print "(loading soup from ";TempStoreTxt;" directory)"
 While WarFilename<>""
  SoupEntry = 0
  K=InStr(WarFilename,".")
  If K > 1 Then SoupEntry = Val(Left(WarFilename,K-1)) 'if numbered put in same pos
  If SoupEntry < 1 Or SoupEntry > SoupSize Then SoupEntry = Int(Rnd * SoupSize + 1)
  WarFilename = TempStoreTxt+PathSym+WarFilename '1.04x8
  Gosub LoadSoupWarrior '1.04x8 (soup load code moved to LoadSoupWarrior:)
  WarFilename = Dir()
 Wend  'load next file
If CounterEvoLen > 0 Then Print "(soup loaded)"
Return

'------------- Load warrior into soup ------------------------------------

LoadSoupWarrior:  '1.04x8 moved into subroutine to call from re-insert code
'WarFilename specifies path/filename
'SoupEntry specifies position to load
Open WarFilename For Input As #1  '1.04x8
CounterEvoLen=0
SoupCode(SoupEntry,1,1)=0
SoupOrigin(SoupEntry)="???"  '1.05x9
SoupGenCount(SoupEntry)=0    '1.05x9
While Not Eof(1)
 Line Input #1, ReadOut
 If Left(ReadOut,8)=";origin " Then SoupOrigin(SoupEntry)=Mid(ReadOut,9) '1.01e1
 If Left(ReadOut,12)=";generation " Then SoupGenCount(SoupEntry)=Val(Mid(ReadOut,13)) '1.01e1
 K = 0
 For I = 1 To NumberOfInstructions
  If Left(ReadOut,6) = EvoOpcode(I) Then K=I
 Next
 'avoid totally broken code if opcode array is changed...
 'if no match then match the first base instruction it finds
 If K = 0 Then
  For I = 1 To NumberOfInstructions
   If Left(ReadOut,3) = Left(EvoOpcode(I),3) Then K=I
  Next
 End If
 If K > 0 And CounterEvoLen < EvoLen Then 'add line of code
  CounterEvoLen+=1
  SoupCode(SoupEntry,1,CounterEvoLen)=K
  ReadOut = LTrim(Mid(ReadOut,7)) 'slice off instruction+spaces
  K = 0
  For I = 1 To 8
   If Left(ReadOut,1) = EvoAdressing(I) Then K=I
  Next
  If K > 0 Then
   SoupCode(SoupEntry,2,CounterEvoLen)=K
   ReadOut=LTrim(Mid(ReadOut,2)) 'slice off 1st mode+spaces
   K=InStr(ReadOut,",") 'get loc of comma
   If K > 0 Then
    SoupCode(SoupEntry,3,CounterEvoLen)=Val(Left(ReadOut,K-1))
    ReadOut=LTrim(Mid(ReadOut,K+1)) 'past comma
    K = 0
    For I = 1 To 8
     If Left(ReadOut,1) = EvoAdressing(I) Then K=I
    Next
    If K > 0 Then
     SoupCode(SoupEntry,4,CounterEvoLen)=K
     ReadOut=LTrim(Mid(ReadOut,2)) 'slice off 2nd mode+spaces
     SoupCode(SoupEntry,5,CounterEvoLen)=Val(ReadOut)
'for debugging...
'        For I = 1 To 5
'        Print SoupCode(SoupEntry,I,CounterEvoLen);" ";
'        Next
'        Print
    Else
     SoupCode(SoupEntry,1,1)=0 'invalid
    EndIf
   Else
    SoupCode(SoupEntry,1,1)=0 'invalid
   EndIf
  Else
   SoupCode(SoupEntry,1,1)=0 'invalid
  EndIf
 EndIf
Wend
Close #1
'If warrior added, add dat's if not EvoLen long...
If SoupCode(SoupEntry,1,1) > 0 Then
 While CounterEvoLen < EvoLen
  CounterEvoLen+=1
  SoupCode(SoupEntry,1,CounterEvoLen)=10
  SoupCode(SoupEntry,2,CounterEvoLen)=1
  SoupCode(SoupEntry,3,CounterEvoLen)=0
  SoupCode(SoupEntry,4,CounterEvoLen)=1
  SoupCode(SoupEntry,5,CounterEvoLen)=0
 Wend
'for debugging...
'   Print "(";WarFilename;" added to soup)"
EndIf
Return

'------------- Pick a random Instruction----------------------------------

PickRandomInstruction:
If MutateByProbability Then
 NewValue = 0
 While NewValue = 0
  If (Rnd * 20000) < ProbSpl Then NewValue = 1
  If (Rnd * 20000) < ProbMov/3 Then NewValue = 2
  If (Rnd * 20000) < ProbMov/3 Then NewValue = 11
  If (Rnd * 20000) < ProbMov/3 Then NewValue = 15
  If (Rnd * 20000) < ProbAdd/3 Then NewValue = 3
  If (Rnd * 20000) < ProbAdd/3 Then NewValue = 13
  If (Rnd * 20000) < ProbAdd/3 Then NewValue = 16
  If (Rnd * 20000) < ProbSne Then NewValue = 4
  If (Rnd * 20000) < ProbSeq Then NewValue = 5
  If (Rnd * 20000) < ProbDjn/2 Then NewValue = 6
  If (Rnd * 20000) < ProbDjn/2 Then NewValue = 7
  If (Rnd * 20000) < ProbJmn Then NewValue = 8
  If (Rnd * 20000) < ProbJmz/2 Then NewValue = 12
  If (Rnd * 20000) < ProbJmz/2 Then NewValue = 14
  If (Rnd * 20000) < ProbJmp Then NewValue = 9
  If (Rnd * 20000) < ProbDat Then NewValue = 10
 Wend
Else
 NewValue = Int(Rnd * NumberOfInstructions + 1)
EndIf
Return

'-----------------Get soup entry--------------------------------------------

GetSoupEntry:
'retrieve warrior from soup...
For J = 1 To EvoLen
 For I = 1 To 5
  SpeciesCode (I,J) = SoupCode (SoupEntry,I,J)
 Next
'  If SpeciesCode (1,J) = 0 Then 'user changed length, make dat...
'   SpeciesCode(1,J)=10
'   SpeciesCode(2,J)=1
'   SpeciesCode(3,J)=0
'   SpeciesCode(4,J)=1
'   SpeciesCode(5,J)=0
'  EndIf
'(not a modifiable parm but leaving commented incase becomes)
Next
For I = 6 To 9
 For J = 1 To EvoLen
  SpeciesCode (I,J) = 0  'set extra bits to 0
 Next
Next
GenCount = SoupGenCount(SoupEntry) '1.01e1
Origin = SoupOrigin(SoupEntry) '1.01e1
Return

'----------------Mutate Species---------------------------------------------

MutateSpecies:
'randomly change array numbers...
CountOfChanges = 0
GenCount+=1 '1.01e1
For J = 1 To EvoLen  'loop through each line
 If Rnd < InsertLineChance Then
  For K = EvoLen To J Step -1
   If K < EvoLen Then
    For I = 1 To 5
     PrevValue = SpeciesCode (I,J)
     NewValue = SpeciesCode (I,J+1)
     SpeciesCode (I,J) = NewValue
    If PrevValue <> NewValue Then CountOfChanges+=1
    Next
   EndIf
  Next
  If Rnd < DupLineChance And J > 1 Then
   For I = 1 To 5
    PrevValue = SpeciesCode (I,J)
    NewValue = SpeciesCode (I,J-1)
    SpeciesCode (I,J) = NewValue
    If PrevValue <> NewValue Then CountOfChanges+=1
   Next
  Else
   CountOfChanges+=5
   Gosub PickRandomInstruction
   SpeciesCode (1,J) = NewValue
   SpeciesCode (2,J) = Int(Rnd * NumberOfAddressModes + 1)
   If Rnd < BigNumChance Then
    SpeciesCode (3,J) = Int(Rnd * CoreSize)
   Else
    SpeciesCode (3,J) = Int(Rnd * EvoLen*2 - EvoLen)
   EndIf
   SpeciesCode (4,J) = Int(Rnd * NumberOfAddressModes + 1)
   If Rnd < BigNumChance Then
    SpeciesCode (5,J) = Int(Rnd*CoreSize)
   Else
    SpeciesCode (5,J) = Int(Rnd*EvoLen*2 - EvoLen)
   EndIf
  EndIf
 EndIf
 If Rnd < DeleteLineChance Then
  For K = J to EvoLen
   If K < EvoLen Then
    For I = 1 To 5  '1.02x2 (was 0)
     PrevValue = SpeciesCode (I,J)
     NewValue = SpeciesCode (I,J+1)
     SpeciesCode (I,J) = NewValue
     If PrevValue <> NewValue Then CountOfChanges+=1
    Next
   Endif
  Next
 EndIf
 If Rnd < SwapRate Then  '1.02x3
  If J > 1 Then 'must be past 1st line
   For I = 1 To 5
    PrevValue = SpeciesCode (I,J-1)
    NewValue = SpeciesCode (I,J)
    SpeciesCode (I,J-1) = NewValue
    SpeciesCode (I,J) = PrevValue
    If PrevValue <> NewValue Then CountOfChanges+=1
   Next
  EndIf
 EndIf
 If Rnd < InstrRate Then  'mod 1.02x4
  PrevValue = SpeciesCode (1,J)
  Gosub PickRandomInstruction
  If EvoOpcode(PrevValue)<>EvoOpcode(NewValue) Then
   SpeciesCode (1,J) = NewValue
   CountOfChanges+=1
  EndIf
 EndIf
 If Rnd < AddrRate Then   'mod 1.02x4
  PrevValue = SpeciesCode (2,J)
  NewValue = Int(Rnd * NumberOfAddressModes + 1)
  If EvoAdressing(PrevValue)<>EvoAdressing(NewValue) Then
   SpeciesCode (2,J) = NewValue
   CountOfChanges+=1
  EndIf
 EndIf
 If Rnd < DataRate Then
  PrevValue = SpeciesCode (3,J)
  NewValue = PreviousValue
  If Rnd < IncDecChance Then
   If Rnd < 0.5 Then
    NewValue = PrevValue - 1
   Else
    NewValue = PrevValue + 1
   EndIf
  Else
   If Rnd < BigNumChance Then
    NewValue = Int(Rnd * CoreSize)
   Else
    NewValue = Int(Rnd * EvoLen * 2 - EvoLen)
   EndIf
  EndIf
  If PrevValue <> NewValue Then
   SpeciesCode (3,J) = NewValue
   CountOfChanges+=1
  EndIf
 EndIf
 If Rnd < AddrRate Then   'mod 1.02x4
  PrevValue = SpeciesCode (4,J)
  NewValue = Int(Rnd * NumberOfAddressModes + 1)
  If EvoAdressing(PrevValue)<>EvoAdressing(NewValue) Then
   SpeciesCode (4,J) = NewValue
   CountOfChanges+=1
  EndIf
 EndIf
 If Rnd < DataRate Then
  PrevValue = SpeciesCode (5,J)
  NewValue = PreviousValue
  If Rnd < IncDecChance Then
   If Rnd < 0.5 Then
    NewValue = PrevValue - 1
   Else
    NewValue = PrevValue + 1
   EndIf
  Else
   If Rnd < BigNumChance Then
    NewValue = Int(Rnd * CoreSize)
   Else
    NewValue = Int(Rnd * EvoLen * 2 - EvoLen)
   EndIf
  EndIf
  If PrevValue <> NewValue Then
   SpeciesCode (5,J) = NewValue
   CountOfChanges+=1
  EndIf
 EndIf
Next J
Return

'-------------Mutate within the soup----------------------------------------------

MutateWithinSoup:
'this evolves warriors within the soup independent of the hill
SoupEntry1 = Int(Rnd*SoupSize+1)
If Topology > 0 Then '1.02x3 ring or grid
 If Rnd < 0.5 Then  'create a fuzzy ring topology...
  SoupEntry2 = Int(SoupEntry1 + (Rnd * Topology + 1))
  If SoupEntry2 > SoupSize Then SoupEntry2 = SoupEntry2 - SoupSize
 Else
  SoupEntry2 = Int(SoupEntry1 - (Rnd * Topology + 1))
  If SoupEntry2 < 1 Then SoupEntry2 = SoupEntry2 + SoupSize
 EndIf
Else 'create a square grid topology (SoupX=Square root of soup size)
 SoupEntry2 = SoupEntry1 + (Int(Rnd * 3)-1) + (Int(Rnd * 3)-1) * SoupX
 If SoupEntry2 < 1 Then SoupEntry2 = SoupEntry2 + SoupSize
 If SoupEntry2 > SoupSize Then SoupEntry2 = SoupEntry2 - SoupSize
EndIf
'if either warrior doesn't exist create a random warrior
If SoupCode (SoupEntry1,1,1) = 0 Then
 SoupEntry = SoupEntry1
 Gosub MakeRandomSoupWarrior
EndIf
If SoupCode (SoupEntry2,1,1) = 0 Then
 SoupEntry = SoupEntry2
 Gosub MakeRandomSoupWarrior
EndIf
'write warrior files to battle...
SoupEntry = SoupEntry1
WarFilename = "soupwar1.red"
Gosub WriteSoupWarrior
SoupEntry = SoupEntry2
WarFilename = "soupwar2.red"
Gosub WriteSoupWarrior
'battle them...
TempStoreTxt=SoupCommand+" -p "+Str(MaxProcesses)+" soupwar1.red soupwar2.red"
If UseWin Then
 Shell TempStoreTxt + " > scores.tmp"
 Open "scores.tmp" For Input As #1
Else
 Open Pipe TempStoreTxt for input as #1
EndIf
'*** read the results
CounterD=0
INPUT #1,ReadOut
CLOSE #1
ReadOut=ReadOut+" "
Do
CounterD = CounterD+1
Loop Until MID$(ReadOut,CounterD,1)=" "
BattleWin=VAL(LEFT$(ReadOut,CounterD-1))
BattleTie=VAL(RIGHT$(ReadOut,LEN(ReadOut)-CounterD))
BattleLoss=SoupRounds-BattleWin-BattleTie  'fix 1.03x5
'mutate winner over loser...
If (BattleWin - BattleLoss) >= SoupWins Then 'change 1.03x6
 SoupEntry = SoupEntry1
 Gosub GetSoupEntry
 SoupEntry = SoupEntry2 'for replacing
Else
 SoupEntry = SoupEntry2
 Gosub GetSoupEntry
 SoupEntry = SoupEntry1
EndIf
'add mutated winner back to soup, replacing loser
Gosub MutateSpecies
For I = 1 To 5
 For J = 1 To EvoLen
  SoupCode (SoupEntry,I,J) = SpeciesCode (I,J)
 Next
Next
SoupOrigin(SoupEntry)=Origin
SoupGenCount(SoupEntry)=GenCount
StageOneRatio=StageOneRatio+1
Return

'--------------Write soup warrior--------------------------------------------

WriteSoupWarrior:
Open WarFilename FOR OUTPUT AS #1
Print #1, ";redcode"
Print #1, ";assert 1"
Print #1, ";origin ";SoupOrigin(SoupEntry) '1.01e1
Print #1, ";generation ";Str(SoupGenCount(SoupEntry)) '1.01e1
'write code
For CounterA=1 To EvoLen
 Print #1, EvoOpcode(SoupCode(SoupEntry,1,CounterA));" ";
 Print #1, EvoAdressing(SoupCode(SoupEntry,2,CounterA));" ";
 Print #1, Str(SoupCode(SoupEntry,3,CounterA));" ,";
 Print #1, EvoAdressing(SoupCode(SoupEntry,4,CounterA));" ";
 Print #1, Str(SoupCode(SoupEntry,5,CounterA))
Next
Print #1, "end"
CLOSE #1
Return

'----------------------Make random soup warrior----------------------------

MakeRandomSoupWarrior:
NumLen=Int(Rnd * EvoLen + 1)
If EvoLen >= 5 Then If NumLen < 5 Then NumLen = 5 '1.05x9
If EvoLen < 5 Then NumLen = EvoLen '1.05x9
For J=1 To NumLen
 Gosub PickRandomInstruction
 SoupCode (SoupEntry,1,J) = NewValue
 SoupCode (SoupEntry,2,J) = Int(Rnd * NumberOfAddressModes + 1)
 If Rnd < BigNumChance Then
  SoupCode (SoupEntry,3,J) = Int(Rnd * CoreSize)
 Else
  SoupCode (SoupEntry,3,J) = Int(Rnd * EvoLen*2 - EvoLen)
 EndIf
 SoupCode (SoupEntry,4,J) = Int(Rnd * NumberOfAddressModes + 1)
 If Rnd < BigNumChance Then
  SoupCode (SoupEntry,5,J) = Int(Rnd * CoreSize)
 Else
  SoupCode (SoupEntry,5,J) = Int(Rnd * EvoLen*2 - EvoLen)
 EndIf
Next J
While NumLen < EvoLen
 NumLen+=1
 SoupCode (SoupEntry,1,NumLen)=10
 SoupCode (SoupEntry,2,NumLen)=1
 SoupCode (SoupEntry,3,NumLen)=0
 SoupCode (SoupEntry,4,NumLen)=1
 SoupCode (SoupEntry,5,NumLen)=0
Wend
SoupOrigin(SoupEntry)="Random "+Str(SoupEntry) '1.01e1
SoupGenCount(SoupEntry)=0 '1.01e1
Return

'------- Change History -------------
'December 27, 2010 Version 1.10
' Adding another mode for constant optimiziation
'April 9, 2010 Version 1.06x16 (WTN)
' Fixed a bug where some soup display modes didn't work
'April 7, 2010 Version 1.06x15 (WTN)
' Modified HTML output to display top-score warrior code
' New INI parm DisplayTS - 0 for no display, 1 to display
'November 3, 2009 Version 1.06x14 (WTN)
' New ReInsMode 5 to re-insert from species instead of hill
' New INI parm RItopPerc - percent of top score for reinsert from species
' Searches species up to HillAge times to find a warrior to reinsert
'October 27, 2009 Version 1.06cs (Fizmo)
' Improved Hints, HTML display mods (now shows hint percentages)
' New INI parm TakeOver - 0=none, 1=hint mode watcher, 2=minimum paper watcher
' New INI parm TakePerc - percentage when takeover mode becomes active
'August 15, 2009 Version 1.05(pre)x10 (WTN)
' When benchmarking enabled, copies best-scoring warrior to "topscore.red"
' New ReInsMode 4 to copy "topscore.red" when re-inserting
'August 13, 2009 Version 1.05(pre)x9 (WTN)
' Random warriors created with at least 5 instructions (or EvoLen if < 5)
' LoadSoupWarrior defaults to origin ??? and generation 0
' Re-insert ignores warriors frozen using hill freeze
' Added sanity protection for modifiable hill koth/freeze/rounds parameters
'August 11, 2009 Version 1.05(pre)x8 (WTN)
' Merged 1.04x8 mod changes from August 3 2009 into 1.05cs code...
' Added ReInsert where hill warriors are copied to random position in soup
' Moved soup warrior load code to LoadSoupWarrior subroutine
' New INI setting ReInsMode - 0=off 1=rnd 2=koth 3=[better] score
' New INI setting ReInsChance - 0 to 1 to determine frequency of re-insertion
' Modified bench print so it also prints origin and generation
'August 11, 2009 Version 1.05cs (Fizmo)
' Fix major bug in hint modes
' Add more complexity to hint modes
' Add new Feature: Embedding evolved code into predefined code
' Add new INI setting regarding embedding feature
'July 31, 2009 Version 1.04x7 (WTN)
' Modified custom soup display so lines have no spacing
' Soup only shows if mutation is enabled
'July 28, 2009 Version 1.04cs (Fizmo)
' Implement probabilities for the hint modes if running in mode 7
' Added new INI setting hint-pur, hint-pap, hint-sca, hint-fra and hint-sto
'  for in-evolution adjusting of the hint mode probabilities
' Fixed bug in the paper mode in regards of evolving paper/imp 
' Optimize the paper mode in regard of complexity  
' Change composite into fragment in html generation
' Change Maezumo text in warrior generation
' Altered fragment hint code
'July 24, 2009 Version 1.03x6 (WTN)
' Modified display of soup code
' Condensed report titles to require less screen space
' Writes report to temp file first then copies to index.htm
' Added INI setting SoupWins - how many wins needed to mutate
'July 23, 2009 Version 1.03x5 (WTN/Fizmo)
' Corrected line-end corruptions in a couple places
' Incorporated Fizmo's 1.03 Fragment/Stone Hint mods
' Added origin/generation info to displayed soup warriors
' Made so SDcustom setting is changeable during evolution
' Fixed bug in parallel evolution - changed BattleEvoRounds to SoupRounds
'July 22, 2009 Version 1.02x4 (WTN)
' Modified mutation code to avoid changes that result in equivalent code
' Added INI setting SDcustom to specify soup display string (display mode 5)
' Made so soup display can be used for ring soups too (still rectangular)
' Added display of randomly-selected soup warrior when soup display is enabled
' Added INI setting SW Display to enable/disable soup warrior display
' Fixed bugs in HTML color strings
'July 18, 2009 Version 1.02x3 (WTN)
' Added new INI setting EnableSeed, if 1 (default) adds hill warriors to soup
' Added new INI setting SwapRate (default 0) - chance of swapping lines
' Added new INI setting Topology (default 4) - if 0 selects a grid topology
'  otherwise specifies maximum distance between battles along ring
' Added new INI setting SoupX for width of grid soup (default square)
' Added new INI settings SoupDisplay (0 1 2 3 4) to control soup display
'July 17, 2009 - Version 1.02x2 (WTN)
' Added new INI setting mars to set simulator path/name
' SoupRounds defaults to evo rounds if not specified
' Fixed potential array index issue in MutateSpecies: code
'July 15, 2009 - Version 1.02x1 (WTN)
' Fixed so the MinChanges setting is correct (was off by 1)
' (a) Added "nop" to the instruction list (for seed/mutation possibilities)
'July 14, 2009 - Version 1.01e1a (WTN)
' Added automatic benchmarking, new INI settings EnableBench and BenchDir
' Added tracking of origin, generation and benchscore in warrior comments
' Reworked HTML gen code to show extra info, new INI setting ShowExtra
' Added/modified logic to make somewhat more resistant to INI errors
' Added code to limit hill size to 1000 warriors
' Made so mutation works for all hints, not just pure
' Added code to make it easy to configure OS
' New INI setting SoupRounds to set number of rounds for soup evo
' (a) Made so only *.red *.war and *.rc warriors used from BenchDir
'July 10, 2009 - Version 1.01a (WTN)
' Fixed InstrRate in the HTML display
'July 9, 2009 - Version 1.01 (WTN)
' Modified mutation code that it correctly sets the warrior length
' Modified the pure generation code so all available lines can be used
' Added code to limit soup size to 10,000 and warrior length to 1000
' Changed exit prompt text. Moved a close command
'July 7, 2009 - Version 1.00 (WTN)
' Initial Linux conversion
'July 6, 2009 - Windows version of Maezumo released by Christian Schmidt.
'-------

